/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libMG.h>
#include	<libMG.ph>

int	MGdbAdd(classDb* db, ...)
{
	FILE*	dbFileStream;
	char	id[]		= "MGdbAdd";
	char*	paramPtr	= NULL;
	int	errorCode	= 0;
	int	idx		= 0;
	va_list	paramList;
	
	/* check if we have a valid object */
	if(db == NULL || db->parent.type != CLASS_TYPE_DB)
	{
		fprintf( stderr, "%s error: invalid object type\n", id);
		assert(0);
	}
	paramPtr		= (char*)1;

	/*zzzzzzzzzzzzzz*/
	db->parent.fopenIdx++;
	dbFileStream	= fopen( db->parent.path, "a" );
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx++;
	va_start(paramList, db);		/* Initialize the argument list. */	
	/*zzzzzzzzzzzzzz*/

	idx	= 0;
	while( paramPtr )
	{
		paramPtr		= va_arg(paramList, char*);
		if(!paramPtr)
		{
			break;
		}
		fprintf( dbFileStream, "%s%c", paramPtr, 0 );

		/*
		 * prevents random LINEFEEDS!!!
		 */
		while( fflush( dbFileStream ) );	

		idx++;
		if(idx > db->fieldQty)
		{
			fprintf( stderr, "%s error: fields added (%d) exceed field quantity (%d)\n did you forget to terminate MGdbAdd with a NULL field?\n",
				id, idx, db->fieldQty );
			assert(0);
		}
	}

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;
	va_end(paramList);		/* Clean up. */
	/*zzzzzzzzzzzzzz*/

	fprintf( dbFileStream, "\n" );

	/***************************************************************/
	/* free old records                                            */
	/***************************************************************/
	db->parent.recordIdx = db->parent.recordQty;
	while( db->parent.recordIdx > 0 )
	{
		db->parent.recordIdx--;
		/*zzzzzzzzzzzzzz*/
		db->parent.mallocIdx--;
		if(DEBUG_MGdb)
		{
			fprintf( stdout, "%s debug: %s db->parent.recordIdx = %d\n", 
				id, db->parent.path, db->parent.recordIdx );
			fprintf( stdout, "%s debug: %s freeing db->record[%d] = %s\n", 
				id, db->parent.path, db->parent.recordIdx, db->record[db->parent.recordIdx][0] );
		}
		free( db->record[db->parent.recordIdx] );
		/*zzzzzzzzzzzzzz*/
	}

	/*zzzzzzzzzzzzzz*/
	db->parent.fopenIdx--;
	fclose( dbFileStream );
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;
	free(db->dataBuffer);
	/*zzzzzzzzzzzzzz*/
	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;
	free(db->record);
	/*zzzzzzzzzzzzzz*/

	/***************************************************************/
	/* increase recordQty to reflect new record                    */
	/***************************************************************/
	db->parent.recordQty++;

	MGdbRead( db );
	return(errorCode);
}
			
