/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libMG.h>
#include	<libMG.ph>

classDb* MGdbCreate( char* dbFileName, ... )
{
	FILE*	dbFileStream;
	char	id[]		= "MGdbCreate";
	char*	paramPtr	= NULL;
	int	errorCode	= 0;
	static	classDb*	db;
	va_list			paramList;

	/*zzzzzzzzzzzzzz*/
	db			= (classDb*)malloc(sizeof(classDb));
	db->parent.mallocIdx	= 1;
	/*zzzzzzzzzzzzzz*/

	db->fieldIdx		= 0;
	db->fieldQty		= 0;
	db->parent.bof		= 1;
	db->parent.eof		= 0;
	db->parent.fopenIdx	= 0;
	db->parent.recordIdx	= 0;
	db->parent.recordQty	= 0;
	db->parent.type		= CLASS_TYPE_DB;

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx++;
	MGmSetString( db->parent.path, dbFileName);
	/*zzzzzzzzzzzzzz*/


	if(errorCode)
	{
		fprintf( stderr, "%s error: %s returned errorCode %d\n", id, "MGmSetString", errorCode );
		assert(0);
	}
	paramPtr		= (char*)1;

	/*zzzzzzzzzzzzzz*/
	db->parent.fopenIdx++;
	dbFileStream	= fopen(db->parent.path, "w");
	/*zzzzzzzzzzzzzz*/

	if(!dbFileStream)
	{
		fprintf(stderr, "%s ERROR: unable to open %s\n", id, db->parent.path);
		perror("error");
		assert(0);
	}

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx++;
	va_start(paramList, dbFileName);		/* Initialize the argument list. */	
	/*zzzzzzzzzzzzzz*/

	while( paramPtr && db->fieldQty < MAXPARAMETERS )
	{
		paramPtr		= va_arg(paramList, char*);
		if(paramPtr)
		{
			fprintf(dbFileStream, "%s%c", paramPtr, 0);
		}
		db->fieldQty++;
	}
	fprintf(dbFileStream, "\n");

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;
	va_end(paramList);		/* Clean up. */
	/*zzzzzzzzzzzzzz*/

	db->parent.recordQty++;

	/*zzzzzzzzzzzzzz*/
	db->parent.fopenIdx--;
	fclose(dbFileStream);
	/*zzzzzzzzzzzzzz*/

	MGdbRead( db );

	return(db);
}
