/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libMG.h>
#include	<libMG.ph>

int	MGdbDestroy(classDb* db)
{
	char	id[]		= "MGdbDestroy";
	int	errorCode	= 0;

	/* check if we have a valid object */
	if(db == NULL || db->parent.type != CLASS_TYPE_DB)
	{
		fprintf( stderr, "%s error: invalid object type\n", id);
		assert(0);
	}
	/* set type to 0 indicate this is no longer an object */
	db->parent.type	= 0;

	/*free the memory allocated for the object*/

	/***************************************************************/
	/* free old records                                            */
	/***************************************************************/
	db->parent.recordIdx = db->parent.recordQty;
	while( db->parent.recordIdx > 0 )
	{
		db->parent.recordIdx--;

		/*zzzzzzzzzzzzzz*/
		db->parent.mallocIdx--;
		free( db->record[db->parent.recordIdx] );
		/*zzzzzzzzzzzzzz*/
	}

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;
	free(db->record);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;
	free(db->dataBuffer);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;
	free(db->parent.path);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	db->parent.mallocIdx--;

	if(db->parent.fopenIdx || db->parent.mallocIdx)
	{
		fprintf( stderr, "%s error: db->parent.fopenIdx = %d db->parent.mallocIdx = %d\n",
			id, db->parent.fopenIdx, db->parent.mallocIdx );
		assert(0);
	}

	free(db);
	/*zzzzzzzzzzzzzz*/

	return(errorCode);
}
