/************************************************************************/
/*	Copyright (C) 2005  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libMG.h>
#include	<libMG.ph>

int	MGdirDestroy(classDir* dir)
{
	char	id[]		= "MGdirDestroy";
	int	errorCode	= 0;

	/* check if we have a valid object */
	if(dir == NULL || dir->parent.type != CLASS_TYPE_DIR)
	{
		fprintf( stderr, "%s error: invalid object type\n", id);
		assert(0);
	}
	/* set type to 0 indicate this is no longer an object */
	dir->parent.type	= 0;
	
	while( dir->parent.recordQty )
	{
		dir->parent.recordQty--;

		/*zzzzzzzzzzzzzz*/
		dir->parent.mallocIdx--;
		free( dir->record[dir->parent.recordQty] );
		/*zzzzzzzzzzzzzz*/
	}

	dir->parent.mallocIdx--;
	dir->parent.mallocIdx--;
	if(dir->parent.fopenIdx || dir->parent.mallocIdx)
	{
		fprintf( stderr, "%s error: dir->parent.fopenIdx = %d dir->parent.mallocIdx = %d\n",
			id, dir->parent.fopenIdx, dir->parent.mallocIdx );
		assert(0);
	}
	/*zzzzzzzzzzzzzz*/
	free(dir->record);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	free(dir);
	/*zzzzzzzzzzzzzz*/

	return(errorCode);
}
