/************************************************************************/
/*	Copyright (C) 2005  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>

int	PMGRrAddDependencies( structProperty* property, char* portName )
{
	FILE*	contentsFileStream;
	char	id[]			= "PMGRrAddDependencies";
	char*	buffPtr			= 0;
	char*	buffer			= NULL;
	char*	contentsFileName	= NULL;
	char*	portDependency		= NULL;
	char*	portDependencyDir	= NULL;
	int	bufferSize		= 0;
	int	errorCode		= 0;
	int	fopenIdx		= 0;	
	int	mallocIdx		= 0;
	int	stringSize		= 0;
	
	stringSize	= strlen(PKGDBDIR)
			+ strlen("/")
			+ strlen(portName)
			+ strlen("/")
			+ strlen("+CONTENTS")
			+ 1;

	/*zzzzzzzzzzzzzz*/
	mallocIdx++;
	contentsFileName	= malloc(stringSize);
	/*zzzzzzzzzzzzzz*/

	if(!contentsFileName)
	{
		fprintf( stderr, "%s %s error: unable to allocate %d bytes for contentsFileName\n", id, VERSION, stringSize);
		return(1);
	}
	contentsFileName[0]	= 0;
	strcat(contentsFileName, PKGDBDIR);
	strcat(contentsFileName, "/");
	strcat(contentsFileName, portName);
	strcat(contentsFileName, "/");
	strcat(contentsFileName, "+CONTENTS");

	/****************************************/
	/* get +CONTENTS file into buffer	*/
	/****************************************/

	/*zzzzzzzzzzzzzz*/
	fopenIdx++;
	contentsFileStream	= fopen(contentsFileName, "r");
	/*zzzzzzzzzzzzzz*/
	
	if(!contentsFileStream)
	{
		fprintf( stderr, "%s %s error: could not open %s\n", id, VERSION, contentsFileName );
		perror( "system message" );
		assert(0);
	}
	bufferSize	= MGrFileSize(contentsFileName);

	/*zzzzzzzzzzzzzz*/
	mallocIdx++;
	buffer		= malloc( bufferSize + 1 );
	/*zzzzzzzzzzzzzz*/
	if(!buffer)
	{
		fprintf( stderr, "%s %s error: could not allocate %d bytes for buffer\n", id, VERSION, bufferSize );
		perror( "system message" );
		assert(0);
	}
	buffer[0]	= 0;
	fread(buffer, 1, bufferSize, contentsFileStream );
	buffPtr	= buffer;
	portDependency	= buffer;
	while( ( portDependency = strnstr( buffPtr, "@pkgdep ", bufferSize - (buffPtr - buffer) ) ) )
	{
		portDependency			+= strlen( "@pkgdep " ); 
		stringSize			= strstr( portDependency, "\n" ) - portDependency;
		if(stringSize < 1)
		{
			break;
		}
		portDependency[stringSize]	= 0;

		buffPtr 			= portDependency + stringSize + 1;

		portDependencyDir		= strstr( buffPtr, "@comment DEPORIGIN:" );
		portDependencyDir		+= strlen( "@comment DEPORIGIN:" );
		stringSize			= strstr( portDependencyDir, "\n" ) - portDependencyDir;
		portDependencyDir[stringSize]	= 0;

		buffPtr 			= portDependencyDir + stringSize + 1;

		portDependencyDir--;
		portDependencyDir[0]		= '/';
/*
 *
 * Just a note: Turns out that I had to run while( fflush( dbFileStream ) ) in MGdbAdd to prevent
 * random LINEFEEDS from being placed into the data base, that may pop up again somewhere so I'll
 * leave this comment here in the hope it saves some aggravation in the future
 *
 */ 
/*
printf( "%s %s DEBUG:\nportName-=>%s\nportDependency-=>%s\nportDependencyDir-=>%s\n%s\n",
id, VERSION, portName, portDependency, portDependencyDir, "marker" );
*/
		MGdbAdd( property->dependencyPortsDb, portName, portDependency, portDependencyDir, NULL );
	}

	/*zzzzzzzzzzzzzz*/
	mallocIdx--;
	free(contentsFileName);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	mallocIdx--;
	free(buffer);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	fopenIdx--;
	errorCode	= fclose(contentsFileStream);
	if(errorCode)
	{
		perror("system");
		assert(0);
	}
	/*zzzzzzzzzzzzzz*/

	if( fopenIdx || mallocIdx )
	{
		fprintf( stderr, "%s error: fopenIdx = %d mallocIdx = %d\n",
			id, fopenIdx, mallocIdx );
		assert(0);
	}
	return(0);
}

