/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>

/*
 *	$Author: mike $
 *	$Revision: 1.2 $
 *	$Date: 2005/02/21 17:35:40 $
 *	$Id: PMGRrDoUpgrade.c,v 1.2 2005/02/21 17:35:40 mike Exp $
 *	$Log: PMGRrDoUpgrade.c,v $
 *	Revision 1.2  2005/02/21 17:35:40  mike
 *	PMGRrDoUpgrade:  Added make check-conflicts so we no longer waste
 *	time trying to build a port that is going to fail at installation
 *	time. If there is a conflict port is pkg_delete -f'ed.
 *	
 */

int	PMGRrDoUpgrade( structProperty* property, char* oldPortName )
{
	FILE*	pHandle		= NULL;
	char	id[]		= "PMGRrDoUpgrade";
	char*	buffer		= NULL;
	char*	bufferBase	= NULL;
	char*	command		= NULL;
	char*	oldPortDir	= NULL;
	char*	options		= NULL;
	char*	reason		= NULL;	
	char*	reasonPortName	= NULL;	
	char*	stinker		= NULL;
	int	bufferSize	= 65000;
	int	errorCode	= 0;
	int	fopenCount	= 0;
	int	idx		= 0;
	int	mallocIdx	= 0;
	int	qty		= 0;
	int	stringSize	= 0;

	/* this is so we can signal that the entire portmanager program needs to
	terminate after updating this port*/
	if( strstr( oldPortName, "portmanager" ) )
	{
		property->portManagerUpdated	= 1;
	}
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );

	MGdbGoTop( property->outOfDatePortsDb );
	oldPortDir	= MGdbSeek( property->outOfDatePortsDb, property->fieldOldPortName, oldPortName,
				property->fieldOldPortDir );
	if( !oldPortDir )
	{
		fprintf( stderr, "%s %s error(52): oldPortName %s not found in outOfDatePortsDb\n",
			id, VERSION, oldPortName );
			while( fflush( stderr ) );
		return(9);
	}

	MGdbGoTop( property->configDb );
	options	= MGdbSeek( property->configDb, property->fieldKey, oldPortDir, property->fieldValue );

	MGdbGoTop( property->outOfDatePortsDb );
	reason		= MGdbSeek( property->outOfDatePortsDb, property->fieldOldPortDir, oldPortDir,
				property->fieldReason );

	MGdbGoTop( property->outOfDatePortsDb );
	reasonPortName	= MGdbSeek( property->outOfDatePortsDb, property->fieldOldPortDir, oldPortDir,
				property->fieldNewPortName );		

	fprintf( stdout, "UPGRADING %s reason %s %s\n", oldPortName, reason, reasonPortName  );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );
	/************************************************************************/
	/*			Command "1" " make check-conflicts "		*/
	/************************************************************************/
	if( options )
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make check-conflicts " )
				+ strlen(options)
				+ 1;
		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;
		strcat( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make check-conflicts " );
		strcat( command, options );
	}
	else
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make check-conflicts " )
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;
		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make check-conflicts " );
	}	
	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stdout, "checking for conflicts before building %s\n", oldPortName );
	fprintf( stdout, "%s %s command: #1 of 8  %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );

	errorCode = system(command);

	/*
	 * We have a conflicting port installed, pkg_delete -f'ing the stinker
	 *
	 */
	if(errorCode)
	{
		buffer		= malloc( bufferSize+1 );
		pHandle		= popen( command, "r" );
		fread( buffer, bufferSize, 1, pHandle );

		if( feof( pHandle ) && !ferror( pHandle ) )
		{
			bufferBase	= strstr( buffer, "conflicts with installed package" );
			if( bufferBase )
			{
				/*
				 *
				 * Sample of what to expect in the buffer
				 *
				 * ===>  linux_base-rh-7.3 conflicts with installed package(s):
				 * linux-XFree86-libs-4.3.99.902_2
				 * linux_base-rh-9
				 *
				 */
				bufferBase	= buffer
						+ strlen(oldPortName)
						+ strlen( "===>  conflicts with installed package" );

				/*
				 *
				 * Now for the fun part, rather than trying to parse every possible
				 * port in this buffer, we'll just cycle through the install ports database
				 * and see if any of the names show up in this buffer somewhere, they show up
				 * then they are conflicting ports
				 *
				 */
				 idx	= 0;
				 qty	= MGdbGetRecordQty( property->installedPortsDb );
				while( idx < qty )
				{
					stinker = strstr( bufferBase, MGdbGet( property->installedPortsDb,
								idx, property->fieldInstalledPortName  ) );
					if( stinker )
					{
						stringSize	= strlen( "pkg_delete -f " )
								+ strlen( MGdbGet( property->installedPortsDb,
										idx, property->fieldInstalledPortName ) )
								+ 1;
						free( command );
						command		= malloc( stringSize );
						command[0]	= 0;
						strcat( command, "pkg_delete -f " );
						strcat( command, MGdbGet( property->installedPortsDb,
									idx, property->fieldInstalledPortName ) );		

						fprintf( stdout, "executing: %s\n", command );
						errorCode	= system( command );
						while( fflush( stdout ) );
					}
					idx++;
				}
			}
			else
			{
				/*
				 * the make check-conflicts command worked but there is no
				 * "conflicts with installed package" in the buffer
				 * let this pass to make and see what happens....
				 */
				errorCode	= 0;
				fprintf( stderr, "no \"conflicts with installed package\" in buffer" );
				while( fflush( stderr ) );
			}
			free( buffer );
		} 
		else
		{
			/*
			 * the make check-conflicts command failed for some reason so well just
			 * let this pass to make and see what happens....
			 */
			errorCode	= 0;
			fprintf( stderr, "check-conflicts command failed\n" );
			fprintf( stderr,
				" feof( pHandle )-=>%d ferror( pHandle )-=>%d\n",
				feof( pHandle ), ferror( pHandle ) );
			while( fflush( stderr ) );
		}
	}
	pclose( pHandle );

	/*zzzzzzzzzzzzz*/
	mallocIdx--;
	free( command );
	/*zzzzzzzzzzzzz*/

	if(errorCode)
	{

		fprintf( stderr, "%s %s error: %s conflicts with another installed port\n", id, VERSION, oldPortName );
		fprintf( stderr, "you will have to remove the conflicting port before upgrading %s\n", oldPortName );
		fprintf( stderr, "marking %s as ignored\n", oldPortName );
		fprintf( stdout, "%s\n", DOUBLE_LINES );
		while( fflush( stderr ) );
		MGdbAdd( property->ignoreDb, oldPortDir, "conflicts with another installed port", NULL );
		return(0);
	}

	/************************************************************************/
	/*			Command "2" " make clean "			*/
	/************************************************************************/


	if( options )
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make clean " )
				+ strlen(options)
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcat( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make clean " );
		strcat( command, options );
	}
	else
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make clean " )
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make clean " );
	}	

	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stdout, "intitial clean of work directories \n" );
	fprintf( stdout, "%s %s command: #2 of 8  %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );

	errorCode = system(command);

	/*zzzzzzzzzzzzz*/
	mallocIdx--;
	free( command );
	/*zzzzzzzzzzzzz*/

	if(errorCode)
	{
		fprintf( stderr, "%s %s error: make clean returned an error, cannot continue\n", id, VERSION );
		while( fflush( stderr ) );

		return(0);
	}

	/************************************************************************/
	/*			Command "3" " make "				*/
	/************************************************************************/
	if( options )
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make " )
				+ strlen(options)
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make " );
		strcat( command, options );
	}
	else
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make " )
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make " );
	}	

	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stdout, "update %s \n", oldPortName );
	fprintf( stdout, "%s %s command: #3 of 8  %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );

	errorCode = system(command);
	mallocIdx--;
	free( command );
	if(errorCode)
	{
		fprintf( stdout, "%s %s error: make returned an error, adding %s to ignore.db\n",
			id, VERSION, oldPortDir );
		while( fflush( stdout ) );

		MGdbAdd( property->ignoreDb, oldPortDir, "failed during (2) make", NULL );

		if( mallocIdx || fopenCount )
		{
			assert(0);
		}
		return(0);
	}
	/************************************************************************/
	/*			Command "4" " pkg_create -b "			*/
	/************************************************************************/
	stringSize	= strlen( "cd " )
			+ strlen( TEMPDIR )
			+ strlen("; pkg_create -b ")
			+ strlen( oldPortName )
			+ 1;

	/*zzzzzzzzzzzzz*/
	mallocIdx++;
	command	= (char*)malloc( stringSize ); 
	/*zzzzzzzzzzzzz*/
	command[0]	= 0;

	strcpy( command, "cd " );
	strcat( command, TEMPDIR );
	strcat( command, "; pkg_create -b " );
	strcat( command, oldPortName );

	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stdout, "backing up installed %s before removing it \n", oldPortName );
	fprintf( stdout, "%s %s command: #4 of 8 %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );
	system(command);
	/*
	An error here is no big deal, if for example the port is not installed it will not be able
	to have a backup package made for it.
	*/
	/*zzzzzzzzzzzzz*/
	mallocIdx--;
	free( command );
	/*zzzzzzzzzzzzz*/
	/************************************************************************/
	/*			Command "5" " make deinstall "			*/
	/************************************************************************/

	stringSize	= strlen("pkg_delete -f ") + strlen(oldPortName) + 1;
	/*zzzzzzzzzzzzz*/
	mallocIdx++;
	command		= (char*)malloc(stringSize);
	/*zzzzzzzzzzzzz*/
	command[0]	= 0;
	strcpy(command, "pkg_delete -f ");
	strcat(command, oldPortName);
	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stdout, "removing old %s \n", oldPortName );
	fprintf( stdout, "%s %s command: #5 of 8 %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );
	errorCode	= system(command);
	/*zzzzzzzzzzzzz*/
	mallocIdx--;
	free( command );
	/*zzzzzzzzzzzzz*/

	if( errorCode )
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make deinstall " )
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make deinstall " );
	
		fprintf( stdout, "%s\n", SINGLE_LINES );
		fprintf( stdout, "trying one more way to remove %s...\n", oldPortName );
		fprintf( stdout, "%s %s command: #5 of 8  %s\n", id, VERSION, command );
		fprintf( stdout, "%s\n", SINGLE_LINES );
		while( fflush( stdout ) );
		system(command);

		/*zzzzzzzzzzzzz*/
		mallocIdx--;
		free( command );
		/*zzzzzzzzzzzzz*/
	}

	/************************************************************************/
	/*			Command "6" " make reinstall "			*/
	/************************************************************************/
	if( options )
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make reinstall " )
				+ strlen(options)
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make reinstall " );
		strcat( command, options );
	}
	else
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make reinstall " )
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make reinstall " );
	}	

	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stdout, "installing updated %s \n", oldPortDir );
	fprintf( stdout, "%s %s command: #6 of 8 %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );
	errorCode = system(command);
	/*zzzzzzzzzzzzz*/
	mallocIdx--;
	free( command );
	/*zzzzzzzzzzzzz*/
	if(errorCode)
	{
		stringSize	= strlen("pkg_add ")
				+ strlen(TEMPDIR)
				+ strlen("/")
				+ strlen(oldPortName)
				+ strlen(".tgz")
				+ 1;
		mallocIdx++;
		command		= ( char* )malloc(stringSize); 
		command[0]	= 0;
		strcpy(command, "pkg_add ");
		strcat(command, TEMPDIR);
		strcat(command, "/");
		strcat(command, oldPortName);
		strcat(command, ".tgz");
		fprintf( stdout, "%s\n", SINGLE_LINES );
		fprintf( stderr, "restoring original port from backup \n" );
		fprintf( stderr, "%s %s command: #6!! ***Emergancy restore***  %s\n", id, VERSION, command );
		fprintf( stdout, "%s\n", SINGLE_LINES );
		while( fflush( stdout ) );
		errorCode = system(command);
		/*zzzzzzzzzzzzz*/
		mallocIdx--;
		free( command );
		/*zzzzzzzzzzzzz*/
		if(errorCode)
		{
			fprintf( stdout, "%s %s error: FAILED TO RESTORE BACKUP COPY, really sorry ! \n",
					id, VERSION );
			fprintf( stdout, "%s %s info: adding %s to ignore.db\n", id, VERSION, oldPortDir );
			while( fflush( stdout ) );
			MGdbAdd( property->ignoreDb, oldPortDir, "failed during (6) emergancy restore", NULL );

			if( mallocIdx || fopenCount )
			{
				assert(0);
			}
			return(0);
		}

		fprintf( stdout, "%s\n", SINGLE_LINES );
		fprintf( stdout, "%s %s error: RESTORED BACKUP COPY\n",	id, VERSION );
		fprintf( stdout, "%s %s info: adding %s to ignore.db\n", id, VERSION, oldPortDir );
		MGdbAdd( property->ignoreDb, oldPortDir, "performed (6) emergancy restore", NULL );
		fprintf( stdout, "%s\n", SINGLE_LINES );
		while( fflush( stdout ) );
		if( mallocIdx || fopenCount )
		{
			assert(0);
		}
		return(0);
	}
	else
	{
		stringSize	= strlen("cd ")
				+ strlen(TEMPDIR)
				+ strlen("; rm -f ")
				+ strlen(oldPortName)
				+ strlen(".tgz")
				+ 1;
		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command		= ( char* )malloc(stringSize);
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;
		strcpy( command, "cd " );
		strcat( command, TEMPDIR);
		strcat( command, "; rm -f ");
		strcat( command, oldPortName);
		strcat( command, ".tgz" );
		fprintf( stdout, "%s\n", SINGLE_LINES );
		fprintf( stderr, "deleting backup copy, installation of updated %s successful\n", oldPortDir );
		fprintf( stdout, "%s %s command: #6 of 8 %s\n", id, VERSION, command );
		fprintf( stdout, "%s\n", SINGLE_LINES );
		while( fflush( stdout ) );
		system(command);
		/*
		error is no big deal here, if the backup package wasn't made it can't be deleted...
		*/
		/*zzzzzzzzzzzzz*/
		mallocIdx--;
		free( command );
		/*zzzzzzzzzzzzz*/
	}

	/************************************************************************/
	/*			Command "7" " make package "			*/
	/************************************************************************/
	if( options )
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make package " )
				+ strlen(options)
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make package " );
		strcat( command, options );
	}
	else
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make package " )
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make package " );
	}	

	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stderr, "making package of updated %s \n", oldPortDir );
	fprintf( stdout, "%s %s command: #7 of 8 %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );
	system(command);
	/*zzzzzzzzzzzzz*/
	mallocIdx--;
	free( command );
	/*zzzzzzzzzzzzz*/
	/************************************************************************/
	/*			Command "8" " make clean "			*/
	/************************************************************************/
	if( options )
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make clean " )
				+ strlen(options)
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make clean " );
		strcat( command, options );
	}
	else
	{
		stringSize	= strlen( "cd " )
				+ strlen(PORTSDIR)
				+ strlen(oldPortDir) 
				+ strlen( "; make clean " )
				+ 1;

		/*zzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzz*/
		command[0]	= 0;

		strcpy( command, "cd " );
		strcat( command, PORTSDIR );
		strcat( command, oldPortDir );
		strcat( command, "; make clean " );
	}	

	fprintf( stdout, "%s\n", SINGLE_LINES );
	fprintf( stderr, "terminal clean of work directories\n" );
	fprintf( stdout, "%s %s command: #8 of 8 %s\n", id, VERSION, command );
	fprintf( stdout, "%s\n", SINGLE_LINES );
	while( fflush( stdout ) );
	errorCode = system(command);

	/*zzzzzzzzzzzzz*/
	mallocIdx--;
	free( command );
	/*zzzzzzzzzzzzz*/

	if( mallocIdx || fopenCount )
	{
		assert(0);
	}
        if(errorCode)
        {
                fprintf( stderr, "%s %s error: make clean returned an error, cannot continue\n", id, VERSION );
		while( fflush( stderr ) );
		assert(0);
        }
	return(0);
}
