/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>

char*	PMGRrGetPortDir(char* portName)
{
	FILE*		contentsFileStream;
	char		id[]			= "PMGRrGetPortDir"; 
	char*		address			= NULL;
	char*		buffer			= NULL;
	char*		contentsFileName	= NULL;
	char*		portDirTemp		= NULL;
	int		bufferSize		= 0;
	int		stringSize		= 0;
	signed int	fopenIdx		= 0;
	signed int	mallocIdx		= 0;
	static char	portDir[256];	/* because we have to return this */

	/*
	 * we need to prepend an '/'
	 */
	portDir[0]	= '/';	
	portDir[1]	= 0;	/* so strcat will start here */

	stringSize	= strlen(PKGDBDIR)
			+ strlen("/")
			+ strlen(portName)
			+ strlen("/")
			+ strlen("+CONTENTS")
			+ 1;

	/*z(+1)zzzzzzzzz*/
	mallocIdx++;
	contentsFileName	= (char*)malloc(stringSize);
	/*zzzzzzzzzzzzzz*/

	if(!contentsFileName)
	{
		fprintf( stderr, "%s %s error: unable to allocate %d bytes for contentsFileName\n", id, VERSION, stringSize);
		assert(0);
	}
	contentsFileName[0]	= 0;

	strcpy(contentsFileName, PKGDBDIR);
	strcat(contentsFileName, "/");
	strcat(contentsFileName, portName);
	strcat(contentsFileName, "/");
	strcat(contentsFileName, "+CONTENTS");

	/****************************************/
	/* get +CONTENTS file into buffer	*/
	/****************************************/

	/*z(+1)zzzzzzzzz*/
	fopenIdx++;
	contentsFileStream	= fopen(contentsFileName, "r");
	/*zzzzzzzzzzzzzz*/

	if(!contentsFileStream)
	{
		fprintf( stderr, "%s %s error: could not open %s\n", id, VERSION, contentsFileName );
		perror( "system message" );
		assert(0);
	}
	bufferSize	= MGrFileSize(contentsFileName);

	/*z(-1)zzzzzzzzz*/
	mallocIdx--;
	free( contentsFileName );
	/*zzzzzzzzzzzzzz*/

	/*z(+2)zzzzzzzzz*/
	mallocIdx++;
	buffer		= ( char* )malloc(bufferSize);
	/*zzzzzzzzzzzzzz*/

	buffer[0]	= 0;
	if(!buffer)
	{
		fprintf( stderr, "%s %s error: could allocate %d bytes for %s buffer\n",
			 id, VERSION, bufferSize, contentsFileName );
		perror( "system message" );
		assert(0);
	}	
	fread(buffer, 1, bufferSize, contentsFileStream );

	/*z(-1)zzzzzzzzz*/
	fopenIdx--;
	fclose( contentsFileStream );
	/*zzzzzzzzzzzzzz*/

	address = strnstr(buffer, "@comment ORIGIN:", bufferSize);
	if(!address)
	{
		fprintf( stderr, "%s %s error: \"@comment ORIGIN:\" not found in %s\n", id, VERSION, contentsFileName );
		fprintf( stderr, "\t\t%s installation is corrupt!\n", portName );
		fprintf( stderr, "\t\trecomend running \"pkg_delete -f %s\" then manually reinstalling this port\n",
			portName );
		assert(0);
	}
	portDirTemp	= (char*)(address + strlen("@comment ORIGIN:") );
	address = strnstr(portDirTemp, "\n", 256);
	if(!address)
	{
		fprintf( stderr, "%s %s error: \"end of line\" not found in %s\n", id, VERSION, contentsFileName );
		fprintf( stderr, "\t\t%s installation is corrupt!\n", portName );
		fprintf( stderr, "\t\trecomend running \"pkg_delete -f %s\" then manually reinstalling this port\n",
			portName );
		assert(0);
	}
	portDirTemp[address-portDirTemp]	= 0;
	stringSize	= strlen(portDirTemp) + 1;

	/*
	 * No strcpy on purpose to protext pepended '/'
	 */
	strcat(portDir, portDirTemp);

	/*z(-2)zzzzzzzzz*/
	mallocIdx--;
	free(buffer);
	/*zzzzzzzzzzzzzz*/

	if(fopenIdx || mallocIdx)
	{
		fprintf( stderr, "%s %s error: fopenIdx = %d mallocIdx = %d\n",	id, VERSION, fopenIdx, mallocIdx );
		assert(0);
	}

	return(portDir);
}
