/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/

/*
	$Author: mike $
	$Revision: 1.2 $
	$Date: 2005/02/18 06:55:53 $
	$Header: /usr/home/mike/cvsroot/portmanager/libPMGR/src/PMGRrInitialize.c,v 1.2 2005/02/18 06:55:53 mike Exp $
	$Source: /usr/home/mike/cvsroot/portmanager/libPMGR/src/PMGRrInitialize.c,v $
	$Id: PMGRrInitialize.c,v 1.2 2005/02/18 06:55:53 mike Exp $
	$Log: PMGRrInitialize.c,v $
	Revision 1.2  2005/02/18 06:55:53  mike
	set up portmanager --help to read from share/portmanager/help.txt
	
*/	

#include	<libPMGR.h>

int	PMGRrInitialize( structProperty* property, int argc, char** argv )
{
	char*	commandLineKey	= NULL;
	int	errorCode	= 0;
	int	idx		= 0;	
	int	stringSize	= 0;

	property->portManagerUpdated		= 0;
	property->verbose			= 0;

	stringSize				= strlen(SHAREDIR)
						+ strlen(STRIKES_DB)
						+ 1;
	property->strikesDbFileName		= (char*)malloc(stringSize);
	property->strikesDbFileName[0]		= 0;
	strcpy(property->strikesDbFileName, SHAREDIR);
	strcat(property->strikesDbFileName, STRIKES_DB);

	stringSize				= strlen(SHAREDIR)
						+ strlen(COMMANDLINE_DB)
						+ 1;
	property->commandLineDbFileName		= (char*)malloc(stringSize);
	property->commandLineDbFileName[0]	= 0;
	strcpy(property->commandLineDbFileName, SHAREDIR);
	strcat(property->commandLineDbFileName, COMMANDLINE_DB);

	stringSize				= strlen(SHAREDIR)
						+ strlen(PORTS_INSTALLED_DB)
						+ 1;
	property->installedPortsDbFileName	= (char*)malloc(stringSize);
	property->installedPortsDbFileName[0]	= 0;
	strcpy(property->installedPortsDbFileName, SHAREDIR);
	strcat(property->installedPortsDbFileName, PORTS_INSTALLED_DB);
	
	stringSize				= strlen(SHAREDIR)
						+ strlen(PORT_DEPENDENCIES_DB)
						+ 1;
	property->dependencyPortsDbFileName	= (char*)malloc(stringSize);
	property->dependencyPortsDbFileName[0]	= 0;
	strcpy(property->dependencyPortsDbFileName, SHAREDIR);
	strcat(property->dependencyPortsDbFileName, PORT_DEPENDENCIES_DB);
	
	stringSize				= strlen(SHAREDIR)
						+ strlen(PORTS_CACHE_DB)
						+ 1;
	property->cacheDbFileName		= (char*)malloc(stringSize);
	property->cacheDbFileName[0]		= 0;
	strcpy(property->cacheDbFileName, SHAREDIR);
	strcat(property->cacheDbFileName, PORTS_CACHE_DB);

	stringSize				= strlen(SHAREDIR)
						+ strlen(PORTS_OLD_DB)
						+ 1;
	property->oldPortsFileName		= (char*)malloc(stringSize);
	property->oldPortsFileName[0]		= 0;
	strcpy(property->oldPortsFileName, SHAREDIR);
	strcat(property->oldPortsFileName, PORTS_OLD_DB);

	stringSize				= strlen(SHAREDIR)
						+ strlen(IGNORE_DB)
						+ 1;
	property->ignoreDbFileName		= (char*)malloc(stringSize);
	property->ignoreDbFileName[0]		= 0;
	strcpy(property->ignoreDbFileName, SHAREDIR);
	strcat(property->ignoreDbFileName, IGNORE_DB);

	stringSize				= strlen(SHAREDIR)
						+ strlen(CONFIGURE_DB)
						+ 1;
	property->configDbFileName		= (char*)malloc(stringSize);
	property->configDbFileName[0]		= 0;
	strcpy(property->configDbFileName, SHAREDIR);
	strcat(property->configDbFileName, CONFIGURE_DB);

	stringSize				= strlen(ETCDIR)
						+ strlen(CONFIGURE_CONF)
						+ 1;
	property->configConfFileName		= (char*)malloc(stringSize);
	property->configConfFileName[0]		= 0;
	strcpy(property->configConfFileName, ETCDIR);
	strcat(property->configConfFileName, CONFIGURE_CONF);
	
	/*
	 * Set help file name/path
	 */
	stringSize				= strlen( SHAREDIR )
						+ strlen( HELPFILE )
						+ 1;
	property->helpFile			= (char*)malloc( stringSize );
	property->helpFile[0]			= 0;
	strcat( property->helpFile, SHAREDIR );
	strcat( property->helpFile, HELPFILE );
	

	MGmSetString( property->field3strikesPortDir, "field3strikesPortDir" );		/* 3strikesDb field 0 */
	MGmSetString( property->fieldStrikes, "fieldStrikes" );				/* 3strikesDb field 1 */

	MGmSetString( property->fieldCommandLineKey, "fieldCommandLineKey" );		/* commandLineDb field 0 */
	MGmSetString( property->fieldCommandLineValue, "fieldCommandLineValue" );	/* commandLineDb field 1 */

	MGmSetString( property->fieldInstalledPortName, "fieldInstalledPortName" );	/* installedPortsDb field 0 */
	MGmSetString( property->fieldInstalledPortDir, "fieldInstalledPortDir" );	/* installedPortsDb field 1 */

	MGmSetString( property->fieldCachePortDir, "fieldCachePortDir" );		/* cacheDb field 0 */
	MGmSetString( property->fieldAvailablePortName, "fieldAvailablePortName" );	/* cacheDb field 1 */
	MGmSetString( property->fieldMakeFileSize, "fieldMakeFileSize" );		/* cacheDb field 2 */
	MGmSetString( property->fieldMakeFileTime, "fieldMakeFileTime" );		/* cacheDb field 3 */

	MGmSetString( property->fieldChildPortName, "fieldChildPortName" );		/* dependencyPortsDb field 0 */
	MGmSetString( property->fieldDependencyPortName, "fieldDependencyPortName" );	/* dependencyPortsDb field 1 */
	MGmSetString( property->fieldDependencyPortDir, "fieldDependencyPortDir" );	/* dependencyPortsDb field 2 */

	MGmSetString( property->fieldKey, "fieldKey" );					/* configDb field 0 */
	MGmSetString( property->fieldValue, "fieldValue" );				/* configDb field 1 */

	MGmSetString( property->fieldReason, "fieldReason" );				/* outOfDatePortsDb field 2 */
	MGmSetString( property->fieldOldPortName, "fieldOldPortName" );			/* outOfDatePortsDb field 0 */
	MGmSetString( property->fieldOldPortDir, "fieldOldPortDir" );			/* outOfDatePortsDb field 1 */
	MGmSetString( property->fieldNewPortName, "fieldNewPortName" );			/* outOfDatePortsDb field 3 */

	MGmSetString( property->fieldIgnorePortDir, "fieldIgnorePortDir" );		/* ignoreDb field 0 */
	MGmSetString( property->fieldIgnoreReason, "fieldIgnoreReason" );		/* ignoreDb field 1 */

	/*
	build commandLineDb from command line options
	*/
	property->commandLineDb	= MGdbCreate( property->commandLineDbFileName, property->fieldCommandLineKey, 
					property->fieldCommandLineValue, NULL ); 
	idx	= 1;
	while( idx < argc )
	{
		/* command line switch found */
		if( argv[idx][0]	== '-' )
		{
			commandLineKey	= argv[idx];
			MGdbAdd( property->commandLineDb, commandLineKey, " ", NULL );
			/* if next argv exists */
			if( argv[idx+1] && argv[idx+1][0] )
			{
				/* if next argv is a commandLine switch option */
				if( argv[idx+1][0] != '-' )
				{
					idx++;
					/* while argv[idx] exists] */
					while( argv[idx] )
					{
						MGdbAdd( property->commandLineDb, commandLineKey, argv[idx], NULL );
						if( !argv[idx+1] )
						{
							break;
						}
						/* if next argv[idx] is a commandLine switch */
						if( argv[idx+1][0]	== '-' )
						{
							break;
						}
						idx++;
					}
				}
			}
		}
		idx++;			
	}

	return( 0 );
}
