/************************************************************************/
/*	Copyright (C) 2005  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>
int	PMGRrMissingDependencies(structProperty* property)
{
	FILE*	makeDependAllStream;
	FILE*	makeDescribeStream;
	
	char	id[]			= "PMGRrMissingDependencies";
	char*	buffer01		= NULL;
	char*	buffer02		= NULL;
	char*	childPortName		= NULL;
	char*	childPortDir		= NULL;
	char*	command			= NULL;
	char*	dependencyPortDir	= NULL;
	char*	dependencyPortName	= NULL;
	char*	installedPortName	= NULL;
	char*	isOk			= NULL;
	char*	options			= NULL;
	char*	unInstalledPortDir	= NULL;
	char*	unInstalledPortName	= NULL;
	int	IDX_dependencyPortsDb	= 1;
	int	IDX_installedPortsDb	= 1;
	int	QTY_dependencyPortsDb	= 0;
	int	buffer01Idx		= 0;
	int	buffer02Idx		= 0;
	int	fopenIdx		= 0;
	int	mallocIdx		= 0;
	int	stringSize		= 0;
	
	/*****************************************************************************/
	/* insure all dependency ports are installed, if not check "make describe"   */
	/* to veryify acuracy of the dependency *NEW ver 0.2.3* If the dependency    */
	/* directory is not listed by make describe then do not install it!!!        */
	/*****************************************************************************/
	/*
		add to outOfDatePortsDb any dependencies that are missing
		field 0	-=> fieldOldPortName
		field 1 -=> fieldOldPortDir
		field 2 -=> fieldReason (port needs to be updated)
		field 3 -=> fieldNewPortName
	*/
	QTY_dependencyPortsDb	= MGdbGetRecordQty(property->dependencyPortsDb);
	IDX_installedPortsDb	= 1;	/* start at one to skip over field names */
	IDX_dependencyPortsDb	= 1;

	/* cycle through each dependency port and see if it is installed */
	while( IDX_dependencyPortsDb <  QTY_dependencyPortsDb )
	{
		dependencyPortDir	= MGdbGet( property->dependencyPortsDb, IDX_dependencyPortsDb,
						property->fieldDependencyPortDir);

		/* see if dependencyPortsDb's dependencyPortName is installed according to installedPortsDb */ 
		MGdbGoTop( property->installedPortsDb );
		installedPortName		= MGdbSeek( property->installedPortsDb, property->fieldInstalledPortDir,
						dependencyPortDir, property->fieldInstalledPortName );
		if(installedPortName)
		{
			/* if here then dpendency port is installed */
			IDX_dependencyPortsDb++;
			continue;
		}

		/* 
		if here then dependency port is MISSING, need to verify it is still a valid dependency of the port
		named in dependencyPortsDb's fieldChildPortName. If it is valid then add to outOfDatePortsDb
		*/
		dependencyPortName	= MGdbGet( property->dependencyPortsDb, IDX_dependencyPortsDb,
						property->fieldDependencyPortName);

		childPortName		= MGdbGet( property->dependencyPortsDb, IDX_dependencyPortsDb,
						property->fieldChildPortName );
						
		MGdbGoTop( property->installedPortsDb );
		childPortDir		= MGdbSeek( property->installedPortsDb, property->fieldInstalledPortName,
						childPortName, property->fieldInstalledPortDir );

		fprintf( stdout, "%s\n", SINGLE_LINES );
		fprintf( stdout, "-=>MISSING<=- %s[%s] %s %s\n", dependencyPortName, dependencyPortDir,
			"may be a dependency of", childPortName );

		/* set "isOk" if make all-depends-list of child port contains dependencyPortDir */
		MGdbGoTop( property->configDb );
		options		= MGdbSeek( property->configDb, property->fieldKey, childPortDir, 
					property->fieldValue );
		if(options)
		{
			stringSize	= strlen( "cd " )
					+ strlen( PORTSDIR )
					+ strlen( childPortDir )
					+ strlen( "; " )
					+ strlen( "make " )
					+ strlen( options )
					+ strlen( " all-depends-list" )
					+ 1;

			/*zzzzzzzzzzzzzz*/
			mallocIdx++;
			command		= (char*)malloc( stringSize );
			/*zzzzzzzzzzzzzz*/

			command[0]	= 0;
			strcpy( command, "cd " );
			strcat( command, PORTSDIR );
			strcat( command, childPortDir );
			strcat( command,  "; " );
			strcat( command, "make " );
			strcat( command, options );
			strcat( command, " all-depends-list" );
		}
		else
		{
			stringSize	= strlen( "cd " )
					+ strlen( PORTSDIR )
					+ strlen( childPortDir )
					+ strlen( "; " )
					+ strlen( "make " )
					+ strlen( " all-depends-list" )
					+ 1;

			/*zzzzzzzzzzzzzz*/
			mallocIdx++;
			command		= (char*)malloc( stringSize );
			/*zzzzzzzzzzzzzz*/

			command[0]	= 0;
			strcpy( command, "cd " );
			strcat( command, PORTSDIR );
			strcat( command, childPortDir );
			strcat( command,  "; " );
			strcat( command, "make " );
			strcat( command, " all-depends-list" );
		}
		fprintf( stdout, "verifing dependency status of %s (may take awhile) by executing command:\n%s\n",
					dependencyPortName, command );
		while( fflush( stdout ) );
		/*zzzzzzzzzzzzzz*/
		fopenIdx++;
		makeDependAllStream	= popen( command, "r" );
		waitpid(-1, NULL, 0 );
		/*zzzzzzzzzzzzzz*/

		/*zzzzzzzzzzzzzz*/
		mallocIdx++;
		buffer01		= (char*)malloc(128000);
		/*zzzzzzzzzzzzzz*/

		fread( buffer01, 128000, 1, makeDependAllStream );

		/* see if make all-depends-list of childPortDir lists our dependency */
		isOk			= strnstr( buffer01, dependencyPortDir, 128000 );
		if( DEBUG_PMGRrMissingDependencies )
		{
			fprintf( stdout, "%s\n", SINGLE_LINES );
			fprintf( stdout, "%s %s DEBUG: buffer01 -=>%s\n\n", id, VERSION, buffer01 );
			fprintf( stdout, "%s %s DEBUG: childPortDir -=>%s\n", id, VERSION, childPortDir );
			fprintf( stdout, "%s %s DEBUG: dependencyPortDir -=>%s\n", id, VERSION, dependencyPortDir );
			fprintf( stdout, "%s\n", SINGLE_LINES );
		}

		/*zzzzzzzzzzzzzz*/
		mallocIdx--;
		free( command );
		/*zzzzzzzzzzzzzz*/

		/*zzzzzzzzzzzzzz*/
		fopenIdx--;
		pclose( makeDependAllStream );
		/*zzzzzzzzzzzzzz*/

		/*zzzzzzzzzzzzzz*/
		mallocIdx--;
		free( buffer01 );
		/*zzzzzzzzzzzzzz*/

		if( isOk )
		{
			fprintf( stdout, "  *  *  *  *\n" );
			fprintf( stdout, "%s is indeed a missing dependency, adding to list of things to be updated\n",
				dependencyPortName );

			MGdbGoTop( property->installedPortsDb );
			childPortName	= MGdbSeek( property->installedPortsDb, property->fieldInstalledPortDir,
						childPortDir, property->fieldInstalledPortName );

			MGdbAdd( property->outOfDatePortsDb, dependencyPortDir, dependencyPortName,
				"MISSING is a dependency of", childPortName, NULL );
			fprintf( stdout, "  *  *  *  *\n" );

			/* 
			Need to check the dependencies of dependencyPortName
			and add any of those that may also be missing.
			*/
			fprintf( stdout, "checking for %s dependencies that also may not be installed\n",
				dependencyPortName );
			while( fflush( stdout ) );
			MGdbGoTop( property->configDb );
			options		= MGdbSeek( property->configDb, property->fieldKey, dependencyPortDir,
							property->fieldValue );
			if(options)
			{
				stringSize	= strlen( "cd " )
				+ strlen( PORTSDIR )
				+ strlen( dependencyPortDir )
				+ strlen( "; " )
				+ strlen( "make " )
				+ strlen( options )
				+ strlen( " all-depends-list" )
				+ 1;

				/*zzzzzzzzzzzzzz*/
				mallocIdx++;
				command		= (char*)malloc( stringSize );
				/*zzzzzzzzzzzzzz*/

				command[0]	= 0;
				strcpy( command, "cd " );
				strcat( command, PORTSDIR );
				strcat( command, dependencyPortDir );
				strcat( command,  "; " );
				strcat( command, "make " );
				strcat( command, options );
				strcat( command, " all-depends-list" );
			}
			else
			{
				stringSize	= strlen( "cd " )
						+ strlen( PORTSDIR )
						+ strlen( dependencyPortDir )
						+ strlen( "; " )
						+ strlen( "make " )
						+ strlen( " all-depends-list" )
						+ 1;

				/*zzzzzzzzzzzzzz*/
				mallocIdx++;
				command		= (char*)malloc( stringSize );
				/*zzzzzzzzzzzzzz*/

				command[0]	= 0;
				strcpy( command, "cd " );
				strcat( command, PORTSDIR );
				strcat( command, dependencyPortDir );
				strcat( command,  "; " );
				strcat( command, "make " );
				strcat( command, " all-depends-list" );
			}
			fprintf( stdout, "listing %s's known dependencies by executing command:\n%s\n",
				dependencyPortName, command );
			fprintf( stdout, "  *  *  *  *\n" );
			while( fflush( stdout ) );
			/*zzzzzzzzzzzzzz*/
			fopenIdx++;
			makeDependAllStream	= popen( command, "r" );
			waitpid(-1, NULL, 0 );
			/*zzzzzzzzzzzzzz*/

			/*zzzzzzzzzzzzzz*/
			mallocIdx--;
			free( command );
			/*zzzzzzzzzzzzzz*/

			/*zzzzzzzzzzzzzz*/
			mallocIdx++;
			buffer01		= (char*)calloc(128000,1);
			/*zzzzzzzzzzzzzz*/

			fread( buffer01, 128000, 1, makeDependAllStream );

			/*zzzzzzzzzzzzzz*/
			fopenIdx--;
			pclose(makeDependAllStream);
			/*zzzzzzzzzzzzzz*/

			/*
			 * this is to handle things that have been moved to a new directory
			 */
			if( !strlen(buffer01) )
			{
				/*
				 * make all-depends-list may have just returned no dependencies so check
				 * Makefile existence as well
				 */
				stringSize	= strlen( PORTSDIR )
						+ strlen( dependencyPortDir )
						+ strlen( "/Makefile" )
						+ 1;
				command		= malloc( stringSize );
				command[0]	= 0;
				strcat( command, PORTSDIR );
				strcat( command, dependencyPortDir );
				strcat( command, "/Makefile" );
				if( !MGrIfFileExist( command ) )
				{
					fprintf( stdout, "%s %s WARNING: %s is missing! moved maybe? see /usr/ports/MOVED\n",
						id, VERSION, dependencyPortDir );
					fprintf( stdout,
					"removing %s from ports_old.db, whoever is dependent will have to pull it in during make\n",
						dependencyPortName );
					while( fflush( stdout ) );
					property->outOfDatePortsDb	= MGdbDelete( property->outOfDatePortsDb,
										MGdbGetRecordQty( property->outOfDatePortsDb ) -1 );
				}
				free( command );

				/*zzzzzzzzzzzzzz*/
				mallocIdx--;
				free( buffer01 );
				/*zzzzzzzzzzzzzz*/

				if( fopenIdx != 0 || mallocIdx != 0)
				{
					fprintf( stderr, "%s error: fopenIdx = %d mallocIdx = %d\n", id, fopenIdx, mallocIdx );
					assert(0);
				}

				return(0);
			}


			buffer01Idx	= 127999;
			/* convert LINEFEEDs to NULLs */
			while( buffer01Idx )
			{
				if( buffer01[buffer01Idx] == LINEFEED )
				{
					buffer01[buffer01Idx]	= 0;
				}
				buffer01Idx--;
			}

			/* set unInstalledPortDir = dependency dir from "make all-depends-list" */
			while( ( unInstalledPortDir = strstr( buffer01 + buffer01Idx, "/usr/ports/" ) 
						+ strlen( "/usr/ports/" ) ) - strlen( "/usr/ports/" ) )
			{
				unInstalledPortDir--;
				unInstalledPortDir[0]	= '/';
				fprintf( stdout, "dependency -=>%s\n", unInstalledPortDir );
				while( fflush( stdout ) );
				/* see if unInstalledPortDir can be found in installedPortsDb */
				MGdbGoTop( property->installedPortsDb );
				installedPortName	= MGdbSeek( property->installedPortsDb, 
								property->fieldInstalledPortDir, unInstalledPortDir, 
								property->fieldInstalledPortName );
				if( installedPortName )
				{
					fprintf( stdout, "\t%s is installed\n", installedPortName );
				}
				else
				{
					/* 
					get the portname that goes with unInstalledPortDir by running
					"make describe" in unInstalledPortDir's dir
					*/
					MGdbGoTop( property->configDb );
					options		= MGdbSeek( property->configDb, property->fieldKey, 
								unInstalledPortDir, property->fieldValue );
					if(options)
					{


						stringSize	= strlen( "cd " )
								+ strlen( PORTSDIR )
								+ strlen( "/" )
								+ strlen( unInstalledPortDir )
								+ strlen( "; " )
								+ strlen( "make " )
								+ strlen( options )
								+ strlen( " describe" );

						/*zzzzzzzzzzzzzz*/
						mallocIdx++;
						command		= (char*)malloc( stringSize );
						/*zzzzzzzzzzzzzz*/

						command[0]	= 0;
						strcat( command, "cd " );
						strcat( command, PORTSDIR );
						strcat( command, "/" );
						strcat( command, unInstalledPortDir );
						strcat( command, "; " );
						strcat( command,  "make " );
						strcat( command,  options );
						strcat( command,  " describe" );
					}
					else
					{
						stringSize	= strlen( "cd " )
								+ strlen( PORTSDIR )
								+ strlen( unInstalledPortDir )
								+ strlen( "; " )
								+ strlen( "make describe" );
						/*zzzzzzzzzzzzzz*/
						mallocIdx++;
						command		= (char*)malloc( stringSize );
						/*zzzzzzzzzzzzzz*/
						command[0]	= 0;
						strcpy( command, "cd " );
						strcat( command, PORTSDIR );
						strcat( command, unInstalledPortDir );
						strcat( command, "; " );
						strcat( command, "make describe" );
					}
					fprintf( stdout, "\texecuting: %s\n", command );
					while( fflush( stdout ) );
					/*zzzzzzzzzzzzzz*/
					fopenIdx++;
					makeDescribeStream	= popen( command, "r" );
					waitpid(-1, NULL, 0 );
					/*zzzzzzzzzzzzzz*/

					/*zzzzzzzzzzzzzz*/
					mallocIdx--;
					free( command );
					/*zzzzzzzzzzzzzz*/

					/*zzzzzzzzzzzzzz*/
					mallocIdx++;
					buffer02			= (char*)calloc(128000,1);
					/*zzzzzzzzzzzzzz*/

					fread( buffer02, 128000, 1, makeDescribeStream );

					/*zzzzzzzzzzzzzz*/
					fopenIdx--;
					pclose(makeDescribeStream);
					/*zzzzzzzzzzzzzz*/

					buffer02Idx	= 127999;
					/* convert "|"s tp NULLs	*/
					while( buffer02Idx )
					{
						if( buffer02[buffer02Idx] == '|' )
						{
							buffer02[buffer02Idx]	= 0;
						}
						buffer02Idx--;
					}
					unInstalledPortName	= buffer02;
					fprintf( stdout, "  *  *  *  *\n" );
					fprintf( stdout, "adding %s to list of things to be upgraded/added.\n",
						unInstalledPortName );
					MGdbAdd( property->outOfDatePortsDb, unInstalledPortDir, unInstalledPortName,
						"MISSING is a dependency of", dependencyPortName, NULL );

					/*zzzzzzzzzzzzzz*/
					mallocIdx--;
					free( buffer02 );
					/*zzzzzzzzzzzzzz*/
				}

				buffer01Idx	+= strlen( unInstalledPortDir ) + strlen( "/usr/ports" ) + 1;
			}

			fprintf( stdout, "%s\n", SINGLE_LINES ); 
			fflush( stdout);

			/*zzzzzzzzzzzzzz*/
			mallocIdx--;
			free( buffer01 );
			/*zzzzzzzzzzzzzz*/

		}
		else	/* from if(isOk) */
		{
			fprintf( stdout, "  *  *  *  *\n" );
			fprintf( stdout, 
				"%s is no longer a dependency of %s\n forcing rebuild of %s to fix /var/db/pkg/%s/+CONTENTS file.\n",
				dependencyPortName, childPortName, childPortName, childPortName );
			fprintf( stdout, "  *  *  *  *\n" );
			fprintf( stdout, 
				"WARNING:  %s may conflict with a new %s dependency\nand may have to be manually removed with \"pkg_delete -f %s\".\nIf portmanager fails during rebuild of %s then review\n/usr/ports/UPDATING and also note what is at the bottom of /usr/ports/MOVED.\n",
				dependencyPortName, childPortName, dependencyPortName, childPortName );
			while( fflush( stdout ) );
			MGdbAdd( property->outOfDatePortsDb, childPortDir, childPortName,
				"built with old/no longer in service dependency of", dependencyPortName, NULL );
		}
		IDX_dependencyPortsDb++;
	}
	if( fopenIdx != 0 || mallocIdx != 0)
	{
		fprintf( stderr, "%s error: fopenIdx = %d mallocIdx = %d\n", id, fopenIdx, mallocIdx );
		assert(0);
	}
	return(0);
}
