/************************************************************************/
/*      Copyright (C) 2004  Michael C. Shultz                           */
/*                                                                      */
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.                                      */
/*                                                                      */
/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */
/*                                                                      */
/* You should have received a copy of the GNU General Public License    */
/* along with this program; if not, write to the Free Software          */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA            */
/*  02111-1307, USA.                                                    */
/*                                                                      */
/* Michael C. Shultz                                                    */
/* ringworm01@gmail.com                                                    */
/* Box 3238 Landers, CA 92285                                           */
/************************************************************************/
#include	<libPMGR.h>
/***********************************************************************/
/* awk script - used to parse pm-020.conf                              */
/***********************************************************************/
/*
#!/bin/sh

HELP="usage: dbConfigure.sh %%PREFIX%%/etc/portmanager/pm-020.conf %%PREFIX%%/share/portmanager/configure.db"
if test $1
then
	if test $2
	then
	
echo "keyzzNULLzzvaluezzNULLzz" > $2;awk 'BEGIN{ FS = "|" } NF == 3 && $1 !~ /#/  && $1 !~ /CATEGORY\/PORT/ && $2 !~ /#/ {print $1 "zzNULLzz" $2 "zzNULLzz"}' $1 >> $2

	else
		echo $HELP
	fi
else
	echo $HELP
fi
*/
/***********************************************************************/
int	PMGRrReadConfigure( structProperty* property )
{
	FILE*	configDbStream;
	char*	configFileNameOld	= NULL;
	char	id[]			= "PMGRrReadConfigure";
	char*	buffer			= NULL;
	char*	command			= NULL;
	char*	nullBase		= NULL;
	int	bufferIdx		= 0;
	int	configDbFileSize	= 0;
	int	fopenIdx		= 0;
	int	mallocIdx		= 0;
	int	stringSize		= 0;

	/*************************************/
	/* update old conf file if it exists */
	/*************************************/
	stringSize		= strlen( ETCDIR)
				+ strlen( "/portmanager.conf" )
				+1;
	/*zzzzzzzzzzzzzz*/
	mallocIdx++;
	configFileNameOld	= (char*)malloc( stringSize );
	/*zzzzzzzzzzzzzz*/

	configFileNameOld[0]	= 0;
	strcpy( configFileNameOld, ETCDIR);
	strcat( configFileNameOld, "/portmanager.conf" ); 
	if( MGrIfFileExist( configFileNameOld ) )
	{

		stringSize	= strlen( "mv " )
				+ strlen( configFileNameOld )
				+ strlen( " " )
				+ strlen( configFileNameOld )
				+ strlen( "_OLD" )
				+ 1;

		/*zzzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize );
		/*zzzzzzzzzzzzzz*/

		command[0]	= 0;

		strcpy( command, "mv " );
		strcat( command, configFileNameOld );
		strcat( command, " " );
		strcat( command, configFileNameOld );
		strcat( command, "_OLD" );
		fprintf( stdout, "moving %s to %s%s\n", configFileNameOld, configFileNameOld, "_OLD" );
		fprintf( stdout, "portmanager configuration file is now called %s. Please review %s%s and %s and make any nessesary changes.\n",
			property->configConfFileName, property->configConfFileName, ".SAMPLE", configFileNameOld);
		system( command );		

		/*zzzzzzzzzzzzzz*/
		mallocIdx--;
		free( command );
		/*zzzzzzzzzzzzzz*/
	}

	/*zzzzzzzzzzzzzz*/
	mallocIdx--;
	free( configFileNameOld );
	/*zzzzzzzzzzzzzz*/

	/***************************************************************************/
	/* if pm-020.conf missing then copy pm-020.conf.SAMPLE to pm-020.conf */
	/***************************************************************************/
	if( !MGrIfFileExist( property->configConfFileName ) )
	{
		stringSize	= strlen( "cp " )
				+ strlen( property->configConfFileName )
				+ strlen( ".SAMPLE " )
				+ strlen( property->configConfFileName )
				+ 1;

		/*zzzzzzzzzzzzzz*/
		mallocIdx++;
		command	= (char*)malloc( stringSize ); 
		/*zzzzzzzzzzzzzz*/

		command[0]	= 0;

		strcpy( command, "cp " );
		strcat( command, property->configConfFileName );
		strcat( command, ".SAMPLE " );
		strcat( command, property->configConfFileName );
		system( command );

		/*zzzzzzzzzzzzzz*/
		mallocIdx--;
		free( command );
		/*zzzzzzzzzzzzzz*/
	}

	/*********************/
	/* parse pm-020.conf */
	/*********************/
	stringSize	= strlen( "echo \"" )
			+ strlen( property->fieldKey )
			+ strlen( "zzNULLzz" )
			+ strlen( property->fieldValue )
			+ strlen( "zzNULLzz\" > " )
			+ strlen( property->configDbFileName )
			+ strlen( ";awk 'BEGIN{ FS = \"|\" } NF == 3 && $1 !~ /#/  && $1 !~ /CATEGORY\\/PORT/ && $2 !~ /#/ {print \"/\" $1 \"zzNULLzz\" $2 \"zzNULLzz\"}' " )
			+ strlen( property->configConfFileName )
			+ strlen( " >> " )
			+ strlen( property->configDbFileName )
			+ 1;

	/*zzzzzzzzzzzzzz*/
	mallocIdx++;
	command		= malloc( stringSize );
	/*zzzzzzzzzzzzzz*/
	command[0]	= 0;
	strcat( command, "echo \"" );
	strcat( command, property->fieldKey );
	strcat( command, "zzNULLzz" );
	strcat( command, property->fieldValue );	
	strcat( command, "zzNULLzz\" > " );
	strcat( command, property->configDbFileName );
	strcat( command, ";awk 'BEGIN{ FS = \"|\" } NF == 3 && $1 !~ /#/  && $1 !~ /CATEGORY\\/PORT/ && $2 !~ /#/ {print \"/\" $1 \"zzNULLzz\" $2 \"zzNULLzz\"}' " );
	strcat( command, property->configConfFileName );
	strcat( command, " >> " );
	strcat( command, property->configDbFileName );

	if(DEBUG_PMGRrReadConfigure)
	{
		fprintf( stdout, "%s %s DEBUG (54): command = %s\n", id, VERSION, command );		
	}
	system( command );

	configDbFileSize	= MGrFileSize(  property->configDbFileName );

	/*zzzzzzzzzzzzzz*/
	mallocIdx++;
	buffer			= malloc( configDbFileSize + 1 );
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	fopenIdx++;
	configDbStream		= fopen( property->configDbFileName, "r" );
	/*zzzzzzzzzzzzzz*/

	fread( buffer, configDbFileSize, 1, configDbStream ); 

	/*zzzzzzzzzzzzzz*/
	fopenIdx--;
	fclose( configDbStream );
	/*zzzzzzzzzzzzzz*/
	
	/* convert zzNULLzz to NULLs */
	while( strstr( buffer + bufferIdx,  "zzNULLzz" ) )
	{
		nullBase	= strstr( buffer + bufferIdx,  "zzNULLzz" );
		nullBase[0]	= 0;
		nullBase[1]	= 0;
		strcat( nullBase+1, nullBase+8 );
		bufferIdx	= (nullBase+1) - buffer;
		configDbFileSize	-= 7;
	}

	/*zzzzzzzzzzzzzz*/
	fopenIdx++;
	configDbStream	= fopen( property->configDbFileName, "w" );
	/*zzzzzzzzzzzzzz*/

	fwrite( buffer, configDbFileSize, 1, configDbStream );

	/*zzzzzzzzzzzzzz*/
	fopenIdx--;
	fclose( configDbStream );
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	mallocIdx--;
	free(buffer);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	mallocIdx--;
	free(command);
	/*zzzzzzzzzzzzzz*/
	if( fopenIdx || mallocIdx)
	{
		fprintf( stderr, "%s error: fopenIdx = %d mallocIdx = %d\n",
			id, fopenIdx, mallocIdx );
		assert(0);
	}
	return( 0 );
}
