/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either VER 2 of the License, or (at    */
/* your option) any later VER.					        */
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>

int	PMGRrShowLeaves( structProperty* property )
{
	char	id[]		= "PMGRrShowLeaves";
	char*	leafPortDir	= NULL;
	char*	leafPortName	= NULL;
	int	errorCode	= 0;
	int	idx		= 0;
	int	stringSize	= 0;
	char*	command		= NULL;

	fprintf( stdout, "%s\n", DOUBLE_LINES );
	fprintf( stdout,"%s %s info: Creating inital data bases\n", id, VERSION );
	fprintf( stdout,"%s\n", SINGLE_LINES );

	errorCode		= PMGRrDbCreate(property);	/* create/open initial databases */
	if(errorCode)
	{
		exit(0);
	}
	

	fprintf( stdout,"%s\n", SINGLE_LINES );
	fprintf( stdout, "Ports with no ports depending on them AKA \"leaf ports.\"\n" );
	fprintf( stdout, "These ports may be safely deinstalled because no other ports rely on them.\"\n" );
	fprintf( stdout, "%s\n", SINGLE_LINES );

	idx	= MGdbGetRecordQty( property->installedPortsDb ) - 1;
	while( idx )
	{
		leafPortName	= MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortName );		
		stringSize	= strlen( PORTSDIR )
				+ strlen( MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortDir ) )
				+ 1;				
		leafPortDir	= (char*)malloc(stringSize);
		leafPortDir[0]	= 0;
		strcpy( leafPortDir, PORTSDIR );
		strcat( leafPortDir, MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortDir ) );
		MGdbGoTop( property->dependencyPortsDb );
		if( !MGdbSeek( property->dependencyPortsDb, property->fieldDependencyPortDir, 
			MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortDir ),
			property->fieldDependencyPortDir ) )
		{
			fprintf( stdout, "%s dir -=> %s\n", leafPortName, leafPortDir );
			stringSize	= strlen( "grep COMMENT " )
					+ strlen( leafPortDir )
					+ strlen( "/Makefile" )
					+ 1;
			command		= (char*)malloc( stringSize );
			command[0]	= 0;
			strcpy( command, "grep COMMENT " );
			strcat( command, leafPortDir );
			strcat( command, "/Makefile" );
			system( command );
			free(command);
			fprintf( stdout, "\n" );
		}
		free( leafPortDir );
		idx--;
		if(!idx)
		{
			break;
		}
	}
	fprintf( stdout, "%s\n", SINGLE_LINES );
	PMGRrDbDestroy( property );
	return(0);
}
