/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either VER 2 of the License, or (at    */
/* your option) any later VER.					        */
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>
#include	<sgtty.h>

int	nuke( char* leafPortDir );
int	rebuildDb( structProperty* property, int* idx );
int	removePort( char* leafPortName );

int	PMGRrShowLeavesDelete( structProperty* property )
{
	char	id[]			= "PMGRrShowLeavesDelete";
	char*	command			= NULL;
	char*	leafPortDir		= NULL;
	char*	leafPortDirShort	= NULL;
	char*	leafPortName		= NULL;
	char*	pkgDescFile		= NULL;
	int	errorCode		= 0;
	int	idx			= 0;
	int	key			= 1;
	int	stringSize		= 0;
	
	fprintf( stdout, "%s\n", DOUBLE_LINES );
	fprintf( stdout,"%s %s info: Creating inital data bases\n", id, VERSION );
	fprintf( stdout,"%s\n", SINGLE_LINES );

	errorCode		= PMGRrDbCreate(property);	/* create/open initial databases */
	if(errorCode)
	{
		exit(0);
	}
	
	idx	= MGdbGetRecordQty( property->installedPortsDb ) - 1;
	while( idx )
	{
		leafPortName	= MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortName );		



		leafPortDirShort	= MGdbGet( property->installedPortsDb, idx,
						property->fieldInstalledPortDir );

		/*
		 * Make sure port isn't in ignore.db
		 */
		MGdbGoTop( property->ignoreDb );
		if( MGdbSeek( property->ignoreDb, property->fieldIgnorePortDir, leafPortDirShort,
			property->fieldIgnorePortDir ) )
		{
printf( " ignoring %s\n", leafPortDirShort );
			idx--;
			continue;
		}

		stringSize	= strlen( PORTSDIR )
				+ strlen( MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortDir ) )
				+ 1;				
		leafPortDir	= (char*)malloc(stringSize);
		leafPortDir[0]	= 0;
		strcpy( leafPortDir, PORTSDIR );

		strcat( leafPortDir, MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortDir ) );
		MGdbGoTop( property->dependencyPortsDb );
		if( !MGdbSeek( property->dependencyPortsDb, property->fieldDependencyPortDir, 
			MGdbGet( property->installedPortsDb, idx, property->fieldInstalledPortDir ),
			property->fieldDependencyPortDir ) )
		{
			if( key != 10 )
			{
				system( "clear" );
				fprintf( stdout,"%s\n", SINGLE_LINES );
				fprintf( stdout, "Ports with no ports depending on them AKA \"leaf ports.\"\n" );
				fprintf( stdout, "These ports may be safely deinstalled because no other ports\nlist these as dependencies.\"\n" );
				fprintf( stdout, "%s\n", SINGLE_LINES );

				fprintf( stdout, "%s %s\n\n", leafPortName, leafPortDir );

				stringSize	= strlen( leafPortDir )
						+ strlen( "/pkg-descr" )
						+ 1;
				pkgDescFile	= (char*)malloc( stringSize );
				pkgDescFile[0]	= 0;
				strcat( pkgDescFile, leafPortDir );
				strcat( pkgDescFile, "/pkg-descr" );

				if( MGrIfFileExist( pkgDescFile ) )
				{
					stringSize	= strlen( "cat " )
							+ strlen( pkgDescFile )
							+ 1;
					command		= (char*)malloc( stringSize );
					command[0]	= 0;
					strcat( command, "cat " );
					strcat( command, pkgDescFile );
					system( command );
					free( pkgDescFile );
					free( command );
					fprintf( stdout, "\n" );
				}
				else
				{
					stringSize	= strlen( "grep COMMENT " )
							+ strlen( leafPortDir )
							+ strlen( "/Makefile" )
							+ 1;
					command		= (char*)malloc( stringSize );
					command[0]	= 0;
					strcat( command, "grep COMMENT " );
					strcat( command, leafPortDir );
					strcat( command, "/Makefile" );
					system( command );
					free(command);
				}
				fprintf( stdout,"%s\n", SINGLE_LINES );
				fprintf( stdout, "\n<SPACE><ENTER> to skip\n<X><ENTER> removes port\n<N><ENTER> *Nuke it*, removes distribution files\n\n" ); 
				fprintf( stdout,"%s\n", SINGLE_LINES );
			}
			key		= getc( stdin );
			switch( key )
			{
				case	KEY_ENTER:
				{
					continue;
				}
				case	KEY_SPACE:
				{
					MGdbAdd( property->ignoreDb, leafPortDirShort, "-slid <SPACE> skipped", NULL );
					fprintf( stdout, "<SPACE> Skipping %s\n\n", leafPortName );
					break;
				}
				case	KEY_n:
				{
					/* nuke() */
					fprintf( stdout, "<n> Nuking %s\n\n", leafPortName );
					removePort( leafPortName );
					nuke( leafPortDir );
					rebuildDb( property, &idx );
					break;
				}
				case	KEY_N:
				{
					/* nuke() */
					fprintf( stdout, "<N> Nuking %s\n\n", leafPortName );
					removePort( leafPortName );
					nuke( leafPortDir );
					rebuildDb( property, &idx );
					break;
				}
				case	KEY_x:
				{
					/* delete() */
					fprintf( stdout, "<x> Removing %s\n\n", leafPortName );
					removePort( leafPortName );
					rebuildDb( property, &idx );
					break;
				}
				case	KEY_X:
				{
					/* delete() */
					fprintf( stdout, "<X> Removing %s\n\n", leafPortName );
					removePort( leafPortName );
					rebuildDb( property, &idx );
					break;
				}
				default:
				{
					MGdbAdd( property->ignoreDb, leafPortDirShort, "-slid <DEFAULT> skipped", NULL );
					fprintf( stdout, "Skipping %s\n\n", leafPortName );
					break;
				}
			}
			fprintf( stdout, "\n" );
		}
		free( leafPortDir );
		idx--;
		if(!idx)
		{
			break;
		}
	}
	fprintf( stdout, "%s\n", SINGLE_LINES );
	PMGRrDbDestroy( property );
	return(0);
}

/***********************************************************************/
int	removePort( char* leafPortName )
{
	char*	command		= NULL;
	int	stringSize	= 0;

	stringSize	= strlen( "pkg_delete -f " )
			+ strlen( leafPortName )
			+ 1;
	command		= (char*)malloc( stringSize );
	command[0]	= 0;
	strcat( command, "pkg_delete -f " );
	strcat( command, leafPortName );
	fprintf( stdout, "\nexecuting: %s\n", command );
	system( command );
	free(command);

 	return( 0 );
}

/***********************************************************************/
int	nuke( char* leafPortDir )
{
	char*	command		= NULL;
	int	stringSize	= 0;

	stringSize	= strlen( "cd " )
			+ strlen( leafPortDir )
			+ strlen( ";make distclean" )
			+ 1;
	command		= (char*)malloc( stringSize );
	command[0]	= 0;
	strcat( command, "cd " );
	strcat( command, leafPortDir );
	strcat( command, ";make distclean" );
	fprintf( stdout, "\nexecuting: %s\n", command );
	system( command );
	free(command);

 	return( 0 );
}

/***********************************************************************/
int	rebuildDb( structProperty* property, int* idx )
{
	int	errorCode	= 0;
	
	PMGRrDbDestroy( property );
	fprintf( stdout, "%s\n", DOUBLE_LINES );
	fprintf( stdout,"Recreating data bases\n" );
	fprintf( stdout,"%s\n", SINGLE_LINES );

	errorCode		= PMGRrDbCreate(property);	/* create/open initial databases */
	if(errorCode)
	{
		exit(0);
	}

	*idx	= MGdbGetRecordQty( property->installedPortsDb ) - 1;

 	return( 0 );
}
