/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	"libPMGR.h"

int	checkForOldDepencies( structProperty* property, char* oldPortName);
int	upgrade(structProperty* property);
int	dualOriginCheck( structProperty* property, char* loopingPortName );

int	PMGRrUpgrade(structProperty* property)
{
	char	id[]			= "pmupgrade";
	char*	command			= NULL;
	char*	xtermTitle		= NULL;
	int	IDX_commandLineDb	= 0;
	int	QTY_commandLineDb	= 0;
	int	QTY_outOfDatePortsDb	= 0;
	int	TOTAL_outOfDatePortsDb	= 0;
	int	errorCode		= 0;
	float	percentDone		= 0;
	int	stringSize		= 0;

	while( 1 == 1 )
	{
		PMGRrStatus(property);
		/****************************************************************/
		/* set initial values						*/
		/****************************************************************/
		property->portManagerUpdated	= 0;	/* 0=not updated 1=updated*/
		property->objIdx		= 0;

		/*zzzzzzzzzzzzzzzzz*/
		property->objIdx++;
		property->outOfDatePortsDb	= MGdbOpen( property->oldPortsFileName );
		/*zzzzzzzzzzzzzzzzz*/

		/*zzzzzzzzzzzzzzzzz*/
		property->objIdx++;
		property->dependencyPortsDb	= MGdbOpen( property->dependencyPortsDbFileName );
		/*zzzzzzzzzzzzzzzzz*/

		/*zzzzzzzzzzzzzzzzz*/
		property->objIdx++;
		property->installedPortsDb	= MGdbOpen( property->installedPortsDbFileName );
		/*zzzzzzzzzzzzzzzzz*/

		/*zzzzzzzzzzzzzzzzz*/
		property->objIdx++;
		property->cacheDb		= MGdbOpen( property->cacheDbFileName );
		/*zzzzzzzzzzzzzzzzz*/


		/*
		 *  Set xterm title bar indicator
		 */
		QTY_outOfDatePortsDb	= MGdbGetRecordQty( property->outOfDatePortsDb );
		if( QTY_outOfDatePortsDb - 1 > TOTAL_outOfDatePortsDb )
		{
			TOTAL_outOfDatePortsDb = QTY_outOfDatePortsDb - 1;
		}
		percentDone	= 100 - ( 100 * ( ( (float)QTY_outOfDatePortsDb - 1 ) / (float)TOTAL_outOfDatePortsDb ) );
fprintf( stdout, "percentDone-=>%d = 100 - ( 100 * ( QTY_outOfDatePortsDb-=>%d / TOTAL_outOfDatePortsDb-=>%d ) ) \n",
	(int)percentDone, QTY_outOfDatePortsDb-1, TOTAL_outOfDatePortsDb );
while( fflush( stdout ) );
		if( !strncmp( getenv("TERM"), "xterm", 5 ) )
		{
			stringSize	= strlen( id )
					+ strlen( " done:%" )
					+ 5;
					
			xtermTitle	= malloc( stringSize );
			xtermTitle[0]	= 0;
			strcat( xtermTitle, id );
			strcat( xtermTitle, " " );
			strcat( xtermTitle, " done:%" );
			strcat( xtermTitle, MGrIntToString( (long)percentDone ) );
			printf( "%c]0;%s%c", '\033', xtermTitle, '\007' );
			free( xtermTitle );
		}
		
		if( QTY_outOfDatePortsDb < 2 )
		{

			/*
			 *  Set xterm title bar indicator
			 */
			if( !strncmp( getenv("TERM"), "xterm", 5 ) )
			{
				stringSize	= strlen( id )
						+ strlen( " finished" )
						+ 5;
				xtermTitle	= malloc( stringSize );
				xtermTitle[0]	= 0;
				strcat( xtermTitle, id );
				strcat( xtermTitle, " " );
				strcat( xtermTitle, " finished" );
				printf( "%c]0;%s%c", '\033', xtermTitle, '\007' );
				free( xtermTitle );
			}

			fprintf( stdout, "%s %s INFO: all ports are up to date\n", id, VERSION );
			while( fflush( stdout ) );
			return(0);
		}

		errorCode	= upgrade( property );

		if(errorCode)
		{
			return(1);
		}

		if(property->portManagerUpdated)
		{
			PMGRrDbDestroy( property );
			fprintf(stdout, "%s\n", SINGLE_LINES);
			fprintf(stdout,	"portmanager just updated itself, executing: portmanager -u \n");
			fprintf(stdout, "sorry:automatic restart is broken for now, restart manually please\n" );
			fprintf(stdout, "%s\n", SINGLE_LINES);
			while( fflush( stdout ) );
			
			/********************************/
			/* reconstruct the command line */
			/********************************/
			QTY_commandLineDb	= MGdbGetRecordQty( property->commandLineDb );
			IDX_commandLineDb	= 1;
			stringSize		= strlen( BINDIR )
						+ strlen( "portmanager " );
			while( IDX_commandLineDb < QTY_commandLineDb )
			{
				/* continue if -ip has no options ) */
				if( !strcmp( MGdbGet( property->commandLineDb, IDX_commandLineDb,
					property->fieldCommandLineKey ), "-ip" ) 
					&&
					!strcmp( MGdbGet( property->commandLineDb, IDX_commandLineDb,
						property->fieldCommandLineValue ), " " ) )
				{
					IDX_commandLineDb++;
					continue;
				}
						
				stringSize	+=	strlen( MGdbGet( property->commandLineDb, IDX_commandLineDb,
								property->fieldCommandLineKey ) )
						+	strlen( MGdbGet( property->commandLineDb, IDX_commandLineDb, 
								property->fieldCommandLineValue ) )
						+ 	2;
				IDX_commandLineDb++;
			}
			stringSize		+= 1;
			command			= (char*)malloc( stringSize );
			command[0]		= 0;
			strcpy( command, BINDIR );
			strcat( command, "portmanager " );
			IDX_commandLineDb	= 1;
			while( IDX_commandLineDb < QTY_commandLineDb )
			{
				/* continue if -ip has no options ) */
				if( !strcmp( MGdbGet( property->commandLineDb, IDX_commandLineDb,
					property->fieldCommandLineKey ), "-ip" ) 
					&&
					!strcmp( MGdbGet( property->commandLineDb, IDX_commandLineDb,
						property->fieldCommandLineValue ), " " ) )
				{
					IDX_commandLineDb++;
					continue;
				}

				strcat( command, MGdbGet( property->commandLineDb, IDX_commandLineDb,
							property->fieldCommandLineKey ) );
							
				strcat( command, " " );

				strcat( command, MGdbGet( property->commandLineDb, IDX_commandLineDb,
							property->fieldCommandLineValue ) );

				strcat( command, " " );

				IDX_commandLineDb++;
			}
			fprintf( stdout, "executing: %s\n", command );
			while( fflush( stdout ) );
			system( command );
			exit(1);
		}

		PMGRrDbDestroy( property );

		/* THIS IS FOR DEBUGGING, a minimal set of open files is expected at this point */
/*
		fprintf( stdout, "%s %s DEBUG(102): run fstat -p %d to test\n", id, VERSION, getpid() );
		getchar();
*/
	}

	return(1);
}
/********************************************************************************/
/* upgrade routine								*/
/********************************************************************************/
int	upgrade(structProperty* property)
{
	char	id[]			= "upgrade";
	char*	ignoreReason		= NULL;
	char*	oldPortDir		= NULL;
	char*	oldPortName		= NULL;
	char*	strike			= NULL;
	int	IDX_outOfDatePortsDb	= 1;
	int	QTY_outOfDatePortsDb	= 0;
	int	errorCode		= 0;
	int	processed		= 0;
	int	skip			= 0;
	
	/****************************************************************************************/
	/* find the priority port to upgrade							*/
	/****************************************************************************************/
	QTY_outOfDatePortsDb	= MGdbGetRecordQty( property->outOfDatePortsDb );
	processed	= 0; 
	while( IDX_outOfDatePortsDb < QTY_outOfDatePortsDb )
	{
		oldPortName	= MGdbGet( property->outOfDatePortsDb, IDX_outOfDatePortsDb,
					property->fieldOldPortName );

		oldPortDir	= MGdbGet( property->outOfDatePortsDb, IDX_outOfDatePortsDb,
					property->fieldOldPortDir );
					
		skip		= checkForOldDepencies( property, oldPortName );

		if( !skip )
		{
			MGdbGoTop( property->ignoreDb );
			ignoreReason	= MGdbSeek( property->ignoreDb, property->fieldIgnorePortDir, oldPortDir,
						property->fieldIgnoreReason );
			if( ignoreReason )
			{
				fprintf( stdout, "%s %s info: ignoring %s, reason: %s\n",
					id, VERSION, oldPortName, ignoreReason );
				IDX_outOfDatePortsDb++;
				while( fflush( stdout ) );
				continue;
			}	
			if( !strcmp( oldPortName, "portmanager" ) )
			{
				property->portManagerUpdated	= 1;	
			}
			/*******************/
			/* 3 strikes check */
			/*******************/
			MGdbGoTop( property->strikesDb );
			strike		= MGdbSeek( property->strikesDb, property->field3strikesPortDir, oldPortDir,
						property->fieldStrikes );  
			if( !strike )
			{
				MGdbAdd( property->strikesDb, oldPortDir, "1", NULL );
			}
			else
			{
				if( strike[0]	== '2' )
				{
					MGdbAdd( property->ignoreDb, oldPortDir, "looping, 3rd attempt at make", NULL );
					IDX_outOfDatePortsDb++;
					continue;
				}
				if( strike[0]	== '1' )
				{
					fprintf( stdout,
						 "%s %s WARNING: This is the second time %s is being built,\n",
						id, VERSION, oldPortName );
					fprintf( stdout, "one more attempt and it will be marked as ignore.\n\n" );
					while( fflush( stdout ) );

					property->strikesDb = MGdbDelete( property->strikesDb,
						MGdbGetRecno( property->strikesDb ) - 1 );

					MGdbAdd( property->strikesDb, oldPortDir, "2", NULL );

					dualOriginCheck( property, oldPortName );
				}
			}
			processed	= 1; 
			errorCode	= PMGRrDoUpgrade( property, oldPortName );
			switch(errorCode)
			{
				case	0:
					return(0);
				case	1:
					fprintf( stderr, "%s %s error: PMGRrDoUpgrade error during initial make clean\n",
						id, VERSION);
					return(1);
				case	2:
					fprintf( stderr, "%s %s error: PMGRrDoUpgrade error during make\n",
						id, VERSION);
					return(2);
				case	5:
					fprintf( stderr, "%s %s error: PMGRrDoUpgrade error during reinstall\n",
						id, VERSION);
					return(5);
				case	8:
					fprintf( stderr, "%s %s error: PMGRrDoUpgrade error during terminal make clean, conflicting port error?\n",
						id, VERSION );
					return(8);
				default:
					fprintf( stderr, "%s %s error: PMGRrDoUpgrade error type unknown\n",
						id, VERSION);
					return(9);
			}
		}
		IDX_outOfDatePortsDb++;
	}
	if( !processed )
	{
		fprintf( stdout, "%s\n", SINGLE_LINES );
		fprintf(stdout, "update of ports collection complete with either some errors, ignored ports or both\n" );
		fprintf( stdout, "%s\n", DOUBLE_LINES );
		while( fflush( stdout ) );
		exit(0); 
	}
	return(0);
}

int	checkForOldDepencies( structProperty* property, char* oldPortName)
{
	char	id[]			= "checkForOldDepencies";
	int	skip			= 0;
	char*	dependencyPortName	= NULL;
	char*	dependencyPortDir	= NULL;
	
	/*
		See if oldPortName has any dependencies(parents) in outOfDatePortsDb, if it
		does then skip it
	*/
	MGdbGoTop( property->dependencyPortsDb );

	while( ( dependencyPortDir = MGdbSeek( property->dependencyPortsDb, property->fieldChildPortName,
		oldPortName, property->fieldDependencyPortDir ) ) )
	{
		MGdbGoTop( property->outOfDatePortsDb );
		if( ( dependencyPortName = MGdbSeek( property->outOfDatePortsDb, property->fieldOldPortDir, 
						dependencyPortDir, property->fieldOldPortName ) ) )
		{
			/*
			 * Twice now I've seen user logs where a  port is its own dependency, this is impossible
			 * and I am assuming it must be something portupgrade is doing to the +CONTENTS file.
			 * So if oldPortName == dependencyPortName we need to not set skip.
			 */		
			if( strcmp( oldPortName, dependencyPortName ) )
			{
				fprintf( stdout, "%s %s skip: %s has a dependency %s that needs to be updated first\n",
					id, VERSION, oldPortName, dependencyPortName );
				while( fflush( stdout ) );
				skip=1;
				return(skip);
			}
		}
	}	
	return( skip );
}


/*
 * look for mismatch between looping port's +CONTENTS file dependency
 * directories and and the dependency's actual point of origin
 *
 * if  dependency.db (looping port name) (dependency name) dependencyDir
 * != installed.db ( dependency.name) dependency.dir 
 *
 */

int	dualOriginCheck( structProperty* property, char* loopingPortName )
{
	char	id[]				= "dualOriginCheck";
	char*	command				= NULL;
	char*	loopingPortDependencyDir	= NULL;
	char*	loopingPortDependencyName	= NULL;
	int	stringSize			= 0;

	/*
	 *
	 * while loopingPortName has dependencies check:
	 *
	 */
	MGdbGoTop( property->dependencyPortsDb );
	while( ( loopingPortDependencyName = MGdbSeek( property->dependencyPortsDb,
						property->fieldChildPortName,
						loopingPortName,
						property->fieldDependencyPortName ) ) )
	{
		/*
		 * Check 1 of 2 used to be 5
		 *
		 * if no loopingPortDependencyName in ports installedDb
		 *
		 *	dependency not installed
		 *
		 *	continue
		 *
		 * else
		 *
		 */
		MGdbGoTop( property->installedPortsDb );
		if( !MGdbSeek( property->installedPortsDb, property->fieldInstalledPortName, loopingPortDependencyName,
				 property->fieldInstalledPortName ) )
		{
			fprintf( stdout, "%s %s info: %s's dependency %s is not installed\n",
				id, VERSION, loopingPortName, loopingPortDependencyName );
			while( fflush( stdout ) );
			continue;

		}

		/*
		 * if loopingPortDependencyDir not in ports installedDb
		 *
		 *	bingo!!!!
		 *
		 * else
		 *
		 */
		loopingPortDependencyDir	= MGdbGet( property->dependencyPortsDb,
							MGdbGetRecno( property->dependencyPortsDb ) -1, 
								property->fieldDependencyPortDir );

		MGdbGoTop( property->installedPortsDb );
		if( !MGdbSeek( property->installedPortsDb, property->fieldInstalledPortDir, loopingPortDependencyDir,
				 property->fieldInstalledPortDir ) )
		{
			fprintf( stdout, "%s %s info: %s has multiple origins! It may be found in more than one /usr/ports/directory\n",
				id, VERSION, loopingPortDependencyName );
			fprintf( stdout, "origin #1: %s\n", loopingPortDependencyDir );
			
			MGdbGoTop( property->installedPortsDb );
			fprintf( stdout, "origin #2: %s\n", MGdbSeek( property->installedPortsDb,
								property->fieldInstalledPortName,
								loopingPortDependencyName,
				 				property->fieldInstalledPortDir ) );
			fprintf( stdout, "removing %s so %s may pull in the correct one\n",
				loopingPortDependencyName, loopingPortName );
			stringSize	= strlen( "pkg_delete -f " )
					+ strlen( loopingPortDependencyName )
					+ 1;
			command		= malloc( stringSize );
			command[0]	= 0;
			strcat( command, "pkg_delete -f " );
			strcat( command, loopingPortDependencyName );
			fprintf( stdout, "executing: %s\n", command );
			while( fflush( stdout ) );
			system( command );
			free( command );
		}
	}
	return( 0 );
}
