/************************************************************************/
/*	Copyright (C) 2005  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or (at*/
/* your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* eso3w83@verizon.net							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>

int	PMGRrVerifyContentsFile(char* portName)
{
	FILE*		contentsFileStream;
	char		id[]			= "PMGRrVerifyContentsFile"; 
	char*		address;
	char*		buffer;
	char*		contentsFileName;
	int		bufferSize		= 0;
	int		errorCode		= 0;
	int		stringSize		= 0;
	signed int	fopenIdx		= 0;
	signed int	mallocIdx		= 0;

	stringSize	= strlen(PKGDBDIR)
			+ strlen("/")
			+ strlen(portName)
			+ strlen("/")
			+ strlen("+CONTENTS")
			+ 1;

	/*zzzzzzzzzzzzzz*/
	mallocIdx++;
	contentsFileName	= (char*)malloc(stringSize);
	/*zzzzzzzzzzzzzz*/

	if(!contentsFileName)
	{
		fprintf( stderr, "%s %s error: unable to allocate %d bytes for contentsFileName\n", id, VERSION, stringSize);
		assert(0);
	}		
	contentsFileName[0]	= 0;
	strcpy(contentsFileName, PKGDBDIR);
	strcat(contentsFileName, "/");
	strcat(contentsFileName, portName);
	strcat(contentsFileName, "/");
	strcat(contentsFileName, "+CONTENTS");

	/****************************************/
	/* get +CONTENTS file into buffer	*/
	/****************************************/

	/*zzzzzzzzzzzzzz*/
	fopenIdx++;
	contentsFileStream	= fopen(contentsFileName, "r");
	/*zzzzzzzzzzzzzz*/

	if(!contentsFileStream)
	{
		fprintf( stderr, "%s %s error: could not open %s\n", id, VERSION, contentsFileName );
		perror( "system message" );
		assert(0);
	}

	bufferSize	= MGrFileSize( contentsFileName );

	/*zzzzzzzzzzzzzz*/
	mallocIdx++;
	buffer		= (char*)malloc( bufferSize );
	/*zzzzzzzzzzzzzz*/

	fread(buffer, 1, bufferSize, contentsFileStream );

	/*zzzzzzzzzzzzzz*/
	fopenIdx--;
	fclose( contentsFileStream );
	/*zzzzzzzzzzzzzz*/

	/*********************************/
	/* Verify @comment ORIGIN exists */
	/*********************************/
	address = strnstr(buffer, "@comment ORIGIN:", bufferSize);
	if(!address)
	{
		fprintf( stderr, "%s %s error: \"@comment ORIGIN:\" not found in %s\n", id, VERSION, contentsFileName );
		fprintf( stderr, "\t\t%s installation is corrupt!\n", portName );
		fprintf( stderr, "\t\trecomend running \"pkg_delete -f %s\" then manually reinstalling this port\n",
			portName );
		assert(0);
	}
	/*********************************/
	/* Verify @name exists */
	/*********************************/
	address = strnstr(buffer, "@name ", bufferSize);
	if(!address)
	{
		fprintf( stderr, "%s %s error: \"@name\" not found in %s\n", id, VERSION, contentsFileName );
		fprintf( stderr, "\t\t%s installation is corrupt!\n", portName );
		fprintf( stderr, "\t\trecomend running \"pkg_delete -f %s\" then manually reinstalling this port\n",
			portName );
		assert(0);
	}

	/*zzzzzzzzzzzzzz*/
	mallocIdx--;
	free(contentsFileName);
	/*zzzzzzzzzzzzzz*/

	/*zzzzzzzzzzzzzz*/
	mallocIdx--;
	free(buffer);
	/*zzzzzzzzzzzzzz*/

	if(fopenIdx || mallocIdx)
	{
		fprintf( stderr, "%s %s error: fopenIdx = %d mallocIdx = %d\n",	id, VERSION, fopenIdx, mallocIdx );
		assert(0);
	}
	return(errorCode);
}
