/************************************************************************/
/*	Copyright (C) 2004  Michael C. Shultz				*/
/*									*/
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either VER 2 of the License, or (at    */
/* your option) any later VER.					        */
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details. 			*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*/
/*  02111-1307, USA.							*/
/* 									*/
/* Michael C. Shultz							*/
/* ringworm01@gmail.com							*/
/* Box 3238 Landers, CA 92285						*/
/************************************************************************/
#include	<libPMGR.h>

#define OFF			-2
#define HELP			0
#define VER 			2
#define PMSTATUS		3
#define PMUPGRADE		4
#define	SHOWLEAVES		5
#define	SHOWLEAVESDELETE	6

int	rPkgAdd( char* port );
int	portmanager( int argc, char** argv );

/*
 * Jumping through a hoop so main is accessable with gdb
 */
int	main( int argc, char** argv )
{
	portmanager( argc, (char**)argv );
	exit(0);
}

int	portmanager( int argc, char** argv )
{
	FILE*	handle		= NULL;
	char	id[]		= "portmanager";
	char	ignorePortDir[80];
	char	s[]		= "-s";
	char	showLeaves[]	= "--show-leaves";
	char	sl[]		= "-sl";
	char	slidDelete[]	= "--show-leaves-interactive-delete";
	char	slid[]		= "-slid";
	char	status[]	= "--status";
	char	u[]		= "-u";
	char	upgrade[]	= "--upgrade";
	char	v[]		= "-v";
	char	version[]	= "--version";
	char*	buffer		= NULL;
	char*	command		= NULL;
	char*	xtermTitle	= NULL;
	int	bufferSize	= 0;
	int	errorCode	= 0;
	int	idx		= 0;	
	int	selection	= 0;
	int	stringSize	= 0;
	structProperty	property;
	char*	bufferIdx	= NULL;
/*
Here is a code snipit from sendmail's alias.c about db locking:

rebuildaliases(map, automatic)
        register MAP *map;
        bool automatic;
{
        SM_FILE_T *af;
        bool nolock = false;
        bool success = false;
        long sff = SFF_OPENASROOT|SFF_REGONLY|SFF_NOLOCK;
        sigfunc_t oldsigint, oldsigquit;
#ifdef SIGTSTP
        sigfunc_t oldsigtstp;
#endif // SIGTSTP
                                    

       // try to lock the source file
        if ((af = safefopen(map->map_file, O_RDWR, 0, sff)) == NULL)
        {
                struct stat stb;

                if ((errno != EACCES && errno != EROFS) || automatic ||
                    (af = safefopen(map->map_file, O_RDONLY, 0, sff)) == NULL)
                {
                        int saveerr = errno;

                        if (tTd(27, 1))
                                sm_dprintf("Can't open %s: %s\n",
                                        map->map_file, sm_errstring(saveerr));
                        if (!automatic && !bitset(MF_OPTIONAL, map->map_mflags))
                                message("newaliases: cannot open %s: %s",
                                        map->map_file, sm_errstring(saveerr));
                        errno = 0;
                        return false;
                }
                nolock = true;
                if (tTd(27, 1) ||
                    fstat(sm_io_getinfo(af, SM_IO_WHAT_FD, NULL), &stb) < 0 ||
                    bitset(S_IWUSR|S_IWGRP|S_IWOTH, stb.st_mode))
                        message("warning: cannot lock %s: %s",
                                map->map_file, sm_errstring(errno));
        }


       // see if someone else is rebuilding the alias file
        if (!nolock &&
            !lockfile(sm_io_getinfo(af, SM_IO_WHAT_FD, NULL), map->map_file,
                      NULL, LOCK_EX|LOCK_NB))
        {
                // yes, they are -- wait until done
                message("Alias file %s is locked (maybe being rebuilt)",
                        map->map_file);
                if (OpMode != MD_INITALIAS)
                {
                        // wait for other rebuild to complete
                        (void) lockfile(sm_io_getinfo(af, SM_IO_WHAT_FD, NULL),
                                        map->map_file, NULL, LOCK_EX);
                }
                (void) sm_io_close(af, SM_TIME_DEFAULT);
                errno = 0;
                return false;
        }



*/


	/*
	 * Insure only one instance of portmanager is running as there is no locking of
	 * data bases yet implemented.
	 *
	 * In debug mode gdb causes extra pids to be reported by ps so instance checking
	 * has to be disabled.
	 *
	 */
#ifndef	DEBUG
		stringSize	= strlen( "ps au | grep 'portmanager'" ) + 1;

		command		= (char*)malloc( stringSize );
		command[0]	= 0;
		strcpy( command, "ps au | grep 'portmanager'" );
		buffer		= (char*)malloc( 16000 );
		handle		= popen( command, "r" );
		free( command );

		fread( buffer, 16000, 1, handle );
		pclose( handle );

		bufferIdx	= strstr( buffer, "portmanager" );
		if( bufferIdx )
		{
			bufferIdx++;
			bufferIdx	= strstr( bufferIdx, "portmanager" );
			if( bufferIdx )
			{
				bufferIdx++;
				bufferIdx	= strstr( bufferIdx, "portmanager" );
				if( bufferIdx )
				{
					bufferIdx++;
					bufferIdx	= strstr( bufferIdx, "portmanager" );
					if( bufferIdx )
					{
						fprintf( stderr, "there is already one instance of portmanager running:\n%s\n",
							buffer );
						exit(0);
					}
				}
			}
		}
		free( buffer );	
#else
		fprintf( stdout, "%s\n", DOUBLE_LINES );
		fprintf( stdout, "%s %s is running in DEBUG mode ", id, VERSION );
		fprintf( stdout, "multiple instances of\n" );
		fprintf( stdout, "portmanager is now possible, " );
		fprintf( stdout, "a second instance will damage data bases so\n" );
		fprintf( stdout, "use caution\n" );
		fprintf( stdout, "%s\n", DOUBLE_LINES );
		while( fflush( stdout ) );
#endif

	/*
	 * set xterm title
	 */
	if( !strncmp( getenv("TERM"), "xterm", 5 ) )
	{
		stringSize	= strlen( id )
				+ 1
				+ strlen( VERSION )
				+ 1;
		xtermTitle	= malloc( stringSize );
		xtermTitle[0]	= 0;
		strcat( xtermTitle, id );
		strcat( xtermTitle, " " );
		strcat( xtermTitle, VERSION );
		printf( "%c]0;%s%c", '\033', xtermTitle, '\007' );
		free( xtermTitle );
	}

	/*
	 * set initial values
	 */
	bufferIdx	= 0;	/* to stop bufferIdx not used warning */
	PMGRrInitialize( &property, argc, (char**)argv );

	/*
	 * help menu
	 */
	if( argc > 1 && ( !strcmp( argv[1], "-h" ) || !strcmp( argv[1],
		"--help" ) ) )
	{
		bufferSize	= MGrFileSize( property.helpFile ) + 1;
		buffer		= (char*)malloc( bufferSize );
		handle		= fopen( property.helpFile, "r" );
		if( !handle )
		{
			fprintf( stderr, "error:  help file is missing!\n" );
			exit( 1 );
		}
		fread( buffer, bufferSize, 1, handle );
		fprintf( stdout, buffer );
		free( buffer );
		fclose( handle );
		exit( 0 );
	}

	property.ignoreDb	= MGdbCreate( property.ignoreDbFileName, property.fieldIgnorePortDir, property.fieldIgnoreReason,
					NULL ); 

	property.strikesDb	= MGdbCreate( property.strikesDbFileName, property.field3strikesPortDir, property.fieldStrikes,
					NULL );
	/*
	 * convert pm-020.conf to config.db
	 */
	PMGRrReadConfigure( &property );
	property.configDb	= MGdbOpen( property.configDbFileName );
	
	idx	= 1;
	while( idx < argc )
	{
		if( !strcmp(argv[idx], "-ip") )
		{
			idx++;
			fprintf( stdout, "%s\n", SINGLE_LINES );
			while( idx < argc && argv[idx][0] != '-' )
			{
				if( argv[idx][0] != '/' )
				{
					ignorePortDir[0]	= '/';
					ignorePortDir[1]	= 0;
					strcat( ignorePortDir, argv[idx] );
				}
				else
				{
					ignorePortDir[0]	= 0;
					strcat( ignorePortDir, argv[idx] );
				}
				
				fprintf( stdout, "%s %s info: adding %s to ignore.db  reason: command line option -ip\n",
					id, VERSION, ignorePortDir );

				MGdbAdd( property.ignoreDb, ignorePortDir, "command line option -ip", NULL );
				idx++;
			}
			idx--;
		}
		idx++;
	}
	idx	= 0;

	while( idx < argc )
	{
		if( !strcmp( argv[idx], showLeaves ) || !strcmp( argv[idx], sl ) )
		{
			selection	= SHOWLEAVES;
			break;
		}

		if( !strcmp( argv[idx], slidDelete ) || !strcmp( argv[idx], slid ) )
		{
			selection	= SHOWLEAVESDELETE;
			break;
		}

		if( !strcmp( argv[idx], status ) || !strcmp( argv[idx], s ) )
		{
			selection	= PMSTATUS;
			break;
		}

		if( !strcmp( argv[idx], upgrade ) || !strcmp( argv[idx], u ) )
		{
			stringSize	= strlen( "rm -f " )
					+ strlen( property.cacheDbFileName )
					+ 1;
			command		= malloc( stringSize );
			command[0]	= 0;
			strcat( command, "rm -f " );
			strcat( command, property.cacheDbFileName );
			fprintf( stdout, "%s %s info: executing %s\n", id, VERSION, command );
			system( command );
			free( command ); 
			selection	= PMUPGRADE;
			break;
		}

		if( !strcmp( argv[idx], version ) || !strcmp( argv[idx], v ) )
		{
			selection	= VER;
			break;
		}
		idx++;
	}

	switch( selection )
	{
		case	VER:
		{
			fprintf( stdout, "\n%s %s VERSION info:\n", id, VERSION );
			break;
		}
		case	PMSTATUS:
		{
			errorCode	= PMGRrStatus(&property);
			if(errorCode)
			{
				fprintf(stderr, "%s %s error: %s returned errorCode %d\n", id, VERSION, "PMGRrStatus", errorCode);
			}
			break;
		}
		case	PMUPGRADE:
		{
			errorCode	= PMGRrUpgrade(&property);
			if(errorCode)
			{
				fprintf(stderr, "%s %s error: %s returned errorCode %d\n", id, VERSION, "PMGRrUpGrade", errorCode);
			}
			break;
		}
		case	SHOWLEAVES:
		{
			PMGRrShowLeaves(&property);
			break;
		}
		case	SHOWLEAVESDELETE:
		{
			PMGRrShowLeavesDelete(&property);
			break;
		}
		default:
			break;
	}
	exit(0);
}
